(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    109609,       2650]
NotebookOptionsPosition[     93636,       2368]
NotebookOutlinePosition[     94069,       2385]
CellTagsIndexPosition[     94026,       2382]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Basic Functions", "Section",
 CellChangeTimes->{{3.8176024244158154`*^9, 
  3.8176024267934504`*^9}},ExpressionUUID->"9f6a3a69-2e05-42e1-becc-\
f96eacfc3532"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExportScreenImage", "[", 
   RowBox[{
    RowBox[{"dir_", ":", 
     RowBox[{
     "$WorkDirectory", "<>", 
      "\"\<Wolfram/UltraRapidCoding/Blog/aoc/screenshots/\>\""}]}], ",", 
    RowBox[{"fn_", ":", "UnixTime"}], ",", 
    RowBox[{"fmt_", ":", "\"\<.png\>\""}]}], "]"}], ":=", 
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{"dir", ",", 
       RowBox[{
        RowBox[{"ToString", "@", 
         RowBox[{"fn", "[", "]"}]}], "<>", "fmt"}]}], "}"}], "]"}], ",", 
    RowBox[{"CurrentScreenImage", "[", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8176017061793027`*^9, 3.8176019300653152`*^9}, {
  3.817601978193319*^9, 3.8176019787467055`*^9}, {3.817602655646903*^9, 
  3.8176026964319944`*^9}, {3.8176029122320585`*^9, 3.8176029139606647`*^9}, {
  3.8176029812659283`*^9, 3.817602984712755*^9}, {3.817603056958552*^9, 
  3.8176030590152054`*^9}, {3.8176032857713585`*^9, 3.8176032963356*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"3ff4b0f9-7b31-45e0-b8ae-a72994a5adbc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SessionSubmit", "[", 
   RowBox[{"ScheduledTask", "[", 
    RowBox[{
     RowBox[{"ExportScreenImage", "[", "]"}], ",", 
     RowBox[{"Quantity", "[", 
      RowBox[{"15", ",", "\"\<Seconds\>\""}], "]"}]}], "]"}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.8176023406245914`*^9, 3.817602341962015*^9}, {
   3.817602380540429*^9, 3.817602405826208*^9}, {3.8176024820516825`*^9, 
   3.817602482198287*^9}, {3.8176025583732786`*^9, 3.817602558479992*^9}, {
   3.817602704221405*^9, 3.8176027110122967`*^9}, {3.8176027510836754`*^9, 
   3.8176027584210525`*^9}, 3.817602877136428*^9, {3.817603299882452*^9, 
   3.8176033070694447`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"0b489f49-6ddc-4734-976e-31a961b7589f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TaskRemove", "/@", 
  RowBox[{"Tasks", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.81760254974341*^9, 3.8176025546572075`*^9}},
 CellLabel->
  "In[195]:=",ExpressionUUID->"edef68a2-135a-4d12-9da8-3c4afc20be6f"],

Cell[BoxData[
 RowBox[{"{", 
  TagBox[
   TemplateBox[{
     RowBox[{
       StyleBox[
        TagBox["TaskObject", "SummaryHead"], "NonInterpretableSummary"], 
       StyleBox["[", "NonInterpretableSummary"], 
       DynamicModuleBox[{
        Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
        TemplateBox[{
          PaneSelectorBox[{False -> GridBox[{{
                PaneBox[
                 ButtonBox[
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "FEBitmaps", "SummaryBoxOpener"]], 
                  ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                  None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                  "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                 Dynamic[{
                   Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                GraphicsBox[{
                  Thickness[0.041666666666666664`], {
                   FaceForm[{
                    RGBColor[0.537, 0.537, 0.537], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     15.5}, {9.501, 15.5}, {9.501, 16.5}, {6.5, 16.5}}}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     5.5}, {9.501, 5.5}, {9.501, 6.5}, {6.5, 6.5}}}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     13.5}, {9.501, 13.5}, {9.501, 14.5}, {6.5, 14.5}}}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     11.5}, {9.501, 11.5}, {9.501, 12.5}, {6.5, 12.5}}}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     9.5}, {9.501, 9.5}, {9.501, 10.5}, {6.5, 10.5}}}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     7.5}, {9.501, 7.5}, {9.501, 8.5}, {6.5, 8.5}}}]}, {
                   FaceForm[{
                    RGBColor[0.392, 0.392, 0.392], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}}, {{{15.5, 6.5}, {8.5, 6.5}, {
                    8.5, 15.5}, {15.5, 15.5}}, {{16.5, 16.5}, {7.5, 16.5}, {
                    7.5, 5.5}, {16.5, 5.5}}}]}, {
                   FaceForm[{
                    RGBColor[1., 1., 1.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{
                    15.5, 15.5}, {8.5, 15.5}, {8.5, 6.5}, {15.5, 6.5}}}]}, {
                   RGBColor[0.392, 0.392, 0.392], 
                   Thickness[0.020833333333333332`], 
                   Opacity[1.], 
                   CapForm["Round"], 
                   JoinForm["Round"], 
                   
                   JoinedCurveBox[{{{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0,
                     2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 
                    0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 
                    0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 
                    0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 
                    0}}, {{0, 2, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1,
                     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{10., 10.221699999999998`}, {10.768, 
                    10.484699999999998`}}, {{12.457, 10.2557}, {12., 
                    10.874699999999999`}}, {{11.543, 10.2557}, {12., 
                    10.874699999999999`}}, {{12., 10.874699999999999`}, {
                    11.261, 11.123699999999998`}}, {{12., 
                    10.874699999999999`}, {12.739, 11.123699999999998`}}, {{
                    12., 10.874699999999999`}, {12., 11.660699999999999`}}, {{
                    12.439, 12.222699999999998`}, {12., 
                    11.660699999999999`}}, {{12.739, 11.123699999999998`}, {
                    13.149000000000001`, 11.705699999999998`}}, {{12.762, 
                    11.932699999999999`}, {13.236, 12.572699999999998`}}, {{
                    13.421, 10.8707}, {12.739, 11.123699999999998`}}, {{14., 
                    10.221699999999998`}, {13.232, 10.484699999999998`}}, {{
                    13.149000000000001`, 10.035699999999999`}, {12.457, 
                    10.2557}}, {{12.437999999999999`, 9.519699999999998}, {
                    12.457, 10.2557}}, {{12., 8.768699999999999}, {12., 
                    9.5887}}, {{11.561, 9.520699999999998}, {11.543, 
                    10.2557}}, {{10.851, 10.035699999999999`}, {11.543, 
                    10.2557}}, {{11.261, 11.123699999999998`}, {10.579, 
                    10.8707}}, {{10.851, 11.706699999999998`}, {11.261, 
                    11.123699999999998`}}, {{10.765, 12.573699999999999`}, {
                    11.238, 11.932699999999999`}}, {{11.562, 
                    12.222699999999998`}, {12., 11.660699999999999`}}, {{12., 
                    10.874699999999999`}, {12., 10.874699999999999`}}, {{
                    11.261, 11.123699999999998`}, {10.768, 
                    10.484699999999998`}, {11.543, 10.2557}, {12., 9.5887}, {
                    12.457, 10.2557}, {13.232, 10.484699999999998`}, {12.739, 
                    11.123699999999998`}, {12.762, 11.932699999999999`}, {12.,
                     11.660699999999999`}, {11.238, 11.932699999999999`}, {
                    11.261, 11.123699999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEqDg+4J69sKlRxmHNEYUORhqqDguPH5DN7VR1g
8lVLdZxluNUdDp5a6Lpts6rDDC2JqVcy1R08HlaJrGtXddDLW8y4R1XTwXLL
ibJ98uoOuUAua5EGVL+GQ8elew+4P2s6hDxeOvvIAw24vNu2z3+vVGg5LLhm
8t4CqN/BNG6Xp4+WA8g5gUDzIfp1HN7w7jOYyaXukGJ937/3uhaa+3Tg7ofp
B5rm6i6kAjcf6PrXj8KUHI55m3c6Au2PL/OXE+NShrsP5LzJnYoOa2SiUqyB
7ofYp+ywy5OHSRvoP5h+mP9h5qOHHwA2dXV1
                    "]}, 
                    CurveClosed -> {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                    0, 0, 0, 0, 0, 0, 1, 1, 1}]}, {
                   FaceForm[{
                    RGBColor[0.902, 0.902, 0.902], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
                    0}, {1, 3, 3}, {1, 3, 3}}}, {{{21.959, 14.8984}, {20.057, 
                    14.281400000000001`}, {20.351, 13.3764}, {20.5, 
                    12.4404}, {20.5, 11.5004}, {20.5, 10.5594}, {20.351, 
                    9.624400000000001}, {20.057, 8.7184}, {21.959, 
                    8.101400000000002}, {22.317999999999998`, 
                    9.206400000000002}, {22.5, 10.3494}, {22.5, 11.5004}, {
                    22.5, 12.650400000000001`}, {22.317999999999998`, 
                    13.7944}, {21.959, 14.8984}}}]}, {
                   FaceForm[{
                    RGBColor[
                    0.9490000000000001, 0.9490000000000001, 
                    0.9490000000000001], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}}}, {{{11.5, 22.5}, {11.5, 20.5}, {13.404, 20.5}, {
                    15.231, 19.903}, {16.783, 18.773}, {17.961, 20.391}, {
                    16.064, 21.771}, {13.83, 22.5}, {11.5, 22.5}}}]}, {
                   FaceForm[{
                    RGBColor[0.929, 0.929, 0.929], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
                    0}, {1, 3, 3}}}, {{{17.9609, 20.3906}, {17.9609, 
                    20.3906}, {16.782899999999998`, 18.7736}, {
                    18.337899999999998`, 17.6416}, {19.4699, 16.0876}, {
                    20.0569, 14.2816}, {21.9589, 14.898599999999998`}, {
                    21.2409, 17.1096}, {19.857899999999997`, 
                    19.008599999999998`}, {17.9609, 20.3906}}}]}, {
                   FaceForm[{
                    RGBColor[0.722, 0.722, 0.722], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}}}, {{{6.2168, 4.2266}, {5.0388, 2.6096000000000004`}, {
                    6.9358, 1.2296000000000005`}, {9.1698, 
                    0.49960000000000004`}, {11.4998, 0.49960000000000004`}, {
                    11.4998, 2.4996000000000005`}, {9.5958, 
                    2.4996000000000005`}, {7.768800000000001, 
                    3.0966000000000005`}, {6.2168, 4.2266}}}]}, {
                   FaceForm[{
                    RGBColor[
                    0.7799999999999999, 0.7799999999999999, 
                    0.7799999999999999], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
                    0}}}, {{{16.783199999999997`, 4.2266}, {
                    15.231199999999998`, 3.0966000000000005`}, {
                    13.404199999999998`, 2.4996000000000005`}, {
                    11.500199999999996`, 2.4996000000000005`}, {
                    11.500199999999996`, 0.49960000000000004`}, {
                    13.830199999999998`, 0.49960000000000004`}, {
                    16.064199999999996`, 1.2296000000000005`}, {
                    17.961199999999998`, 2.6096000000000004`}, {
                    16.783199999999997`, 4.2266}}}]}, {
                   FaceForm[{
                    RGBColor[
                    0.8510000000000001, 0.8510000000000001, 
                    0.8510000000000001], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
                    0}}}, {{{20.0566, 8.718699999999998}, {19.4696, 
                    6.911699999999998}, {18.3376, 5.358699999999999}, {
                    16.7836, 4.226699999999998}, {17.9606, 
                    2.6096999999999984`}, {19.8586, 3.9906999999999986`}, {
                    21.2416, 5.890699999999999}, {21.9586, 
                    8.101699999999997}, {20.0566, 8.718699999999998}}}]}, {
                   FaceForm[{
                    RGBColor[
                    0.6749999999999999, 0.6749999999999999, 
                    0.6749999999999999], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}}}, {{{2.9434, 8.718699999999998}, {1.0414, 
                    8.101699999999997}, {1.7584, 5.890699999999999}, {3.1414, 
                    3.9906999999999986`}, {5.0394, 2.6096999999999984`}, {
                    6.2164, 4.226699999999998}, {4.6624, 5.358699999999999}, {
                    3.5304, 6.911699999999998}, {2.9434, 
                    8.718699999999998}}}]}, {
                   FaceForm[{
                    RGBColor[0.537, 0.537, 0.537], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}}}, {{{6.2168, 18.7734}, {5.0388, 20.3904}, {6.9358, 
                    21.7704}, {9.1698, 22.5004}, {11.4998, 22.5004}, {11.4998,
                     20.5004}, {9.5958, 20.5004}, {7.768800000000001, 
                    19.903399999999998`}, {6.2168, 18.7734}}}]}, {
                   FaceForm[{
                    RGBColor[0.584, 0.584, 0.584], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
                    0}}}, {{{5.0391, 20.3906}, {3.1421, 
                    19.008599999999998`}, {1.7591, 17.1096}, {
                    1.0411000000000006`, 14.898599999999998`}, {
                    2.9431000000000007`, 14.2816}, {3.5301000000000005`, 
                    16.0876}, {4.662100000000001, 17.6416}, {6.2171, 
                    18.7736}, {5.0391, 20.3906}}}]}, {
                   FaceForm[{
                    RGBColor[0.631, 0.631, 0.631], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}, {1, 3, 3}, {0, 1, 0}}}, {{{1.041, 14.8984}, {
                    0.6819999999999999, 13.7944}, {0.4999999999999999, 
                    12.650400000000001`}, {0.4999999999999999, 11.5004}, {
                    0.4999999999999999, 10.3494}, {0.6819999999999999, 
                    9.206400000000002}, {1.041, 8.101400000000002}, {
                    2.9429999999999996`, 8.7184}, {2.649, 
                    9.624400000000001}, {2.5, 10.5594}, {2.5, 11.5004}, {2.5, 
                    12.4404}, {2.649, 13.3764}, {2.9429999999999996`, 
                    14.281400000000001`}, {1.041, 14.8984}}}]}}, AspectRatio -> 
                 Automatic, ImageSize -> {24., 24.}, 
                 PlotRange -> {{0., 24.}, {0., 24.}}], 
                GridBox[{{
                   RowBox[{
                    TagBox["\"Task UUID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"b8989b6d-8769-4b70-90d2-8689505fe959\"", 
                    "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox["\"Task environment: \"", "SummaryItemAnnotation"],
                     "\[InvisibleSpace]", 
                    TagBox["\"Session\"", "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox["\"Task type: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Scheduled\"", "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox[
                    "\"Evaluation expression: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    TagBox[
                    RowBox[{"ExportScreenImage", "[", "]"}], Short], 
                    "SummaryItem"]}]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                 BaseStyle -> {
                  ShowStringCharacters -> False, NumberMarks -> False, 
                   PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
              GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
              AutoDelete -> False, 
              GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              BaselinePosition -> {1, 1}], True -> GridBox[{{
                PaneBox[
                 ButtonBox[
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "FEBitmaps", "SummaryBoxCloser"]], 
                  ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                  None, BaseStyle -> {}, Evaluator -> Automatic, Method -> 
                  "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
                 Dynamic[{
                   Automatic, 
                    3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                GraphicsBox[{
                  Thickness[0.041666666666666664`], {
                   FaceForm[{
                    RGBColor[0.537, 0.537, 0.537], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     15.5}, {9.501, 15.5}, {9.501, 16.5}, {6.5, 16.5}}}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     5.5}, {9.501, 5.5}, {9.501, 6.5}, {6.5, 6.5}}}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     13.5}, {9.501, 13.5}, {9.501, 14.5}, {6.5, 14.5}}}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     11.5}, {9.501, 11.5}, {9.501, 12.5}, {6.5, 12.5}}}], 
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     9.5}, {9.501, 9.5}, {9.501, 10.5}, {6.5, 10.5}}}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{6.5,
                     7.5}, {9.501, 7.5}, {9.501, 8.5}, {6.5, 8.5}}}]}, {
                   FaceForm[{
                    RGBColor[0.392, 0.392, 0.392], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}, {{0, 2, 
                    0}, {0, 1, 0}, {0, 1, 0}}}, {{{15.5, 6.5}, {8.5, 6.5}, {
                    8.5, 15.5}, {15.5, 15.5}}, {{16.5, 16.5}, {7.5, 16.5}, {
                    7.5, 5.5}, {16.5, 5.5}}}]}, {
                   FaceForm[{
                    RGBColor[1., 1., 1.], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{
                    15.5, 15.5}, {8.5, 15.5}, {8.5, 6.5}, {15.5, 6.5}}}]}, {
                   RGBColor[0.392, 0.392, 0.392], 
                   Thickness[0.020833333333333332`], 
                   Opacity[1.], 
                   CapForm["Round"], 
                   JoinForm["Round"], 
                   
                   JoinedCurveBox[{{{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0,
                     2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 
                    0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 
                    0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 
                    0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 0}}, {{0, 2, 
                    0}}, {{0, 2, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1,
                     0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}, {{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{10., 10.221699999999998`}, {10.768, 
                    10.484699999999998`}}, {{12.457, 10.2557}, {12., 
                    10.874699999999999`}}, {{11.543, 10.2557}, {12., 
                    10.874699999999999`}}, {{12., 10.874699999999999`}, {
                    11.261, 11.123699999999998`}}, {{12., 
                    10.874699999999999`}, {12.739, 11.123699999999998`}}, {{
                    12., 10.874699999999999`}, {12., 11.660699999999999`}}, {{
                    12.439, 12.222699999999998`}, {12., 
                    11.660699999999999`}}, {{12.739, 11.123699999999998`}, {
                    13.149000000000001`, 11.705699999999998`}}, {{12.762, 
                    11.932699999999999`}, {13.236, 12.572699999999998`}}, {{
                    13.421, 10.8707}, {12.739, 11.123699999999998`}}, {{14., 
                    10.221699999999998`}, {13.232, 10.484699999999998`}}, {{
                    13.149000000000001`, 10.035699999999999`}, {12.457, 
                    10.2557}}, {{12.437999999999999`, 9.519699999999998}, {
                    12.457, 10.2557}}, {{12., 8.768699999999999}, {12., 
                    9.5887}}, {{11.561, 9.520699999999998}, {11.543, 
                    10.2557}}, {{10.851, 10.035699999999999`}, {11.543, 
                    10.2557}}, {{11.261, 11.123699999999998`}, {10.579, 
                    10.8707}}, {{10.851, 11.706699999999998`}, {11.261, 
                    11.123699999999998`}}, {{10.765, 12.573699999999999`}, {
                    11.238, 11.932699999999999`}}, {{11.562, 
                    12.222699999999998`}, {12., 11.660699999999999`}}, {{12., 
                    10.874699999999999`}, {12., 10.874699999999999`}}, {{
                    11.261, 11.123699999999998`}, {10.768, 
                    10.484699999999998`}, {11.543, 10.2557}, {12., 9.5887}, {
                    12.457, 10.2557}, {13.232, 10.484699999999998`}, {12.739, 
                    11.123699999999998`}, {12.762, 11.932699999999999`}, {12.,
                     11.660699999999999`}, {11.238, 11.932699999999999`}, {
                    11.261, 11.123699999999998`}}, CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEqDg+4J69sKlRxmHNEYUORhqqDguPH5DN7VR1g
8lVLdZxluNUdDp5a6Lpts6rDDC2JqVcy1R08HlaJrGtXddDLW8y4R1XTwXLL
ibJ98uoOuUAua5EGVL+GQ8elew+4P2s6hDxeOvvIAw24vNu2z3+vVGg5LLhm
8t4CqN/BNG6Xp4+WA8g5gUDzIfp1HN7w7jOYyaXukGJ937/3uhaa+3Tg7ofp
B5rm6i6kAjcf6PrXj8KUHI55m3c6Au2PL/OXE+NShrsP5LzJnYoOa2SiUqyB
7ofYp+ywy5OHSRvoP5h+mP9h5qOHHwA2dXV1
                    "]}, 
                    CurveClosed -> {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                    0, 0, 0, 0, 0, 0, 1, 1, 1}]}, {
                   FaceForm[{
                    RGBColor[0.902, 0.902, 0.902], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {1, 3, 3}, {0, 1, 
                    0}, {1, 3, 3}, {1, 3, 3}}}, {{{21.959, 14.8984}, {20.057, 
                    14.281400000000001`}, {20.351, 13.3764}, {20.5, 
                    12.4404}, {20.5, 11.5004}, {20.5, 10.5594}, {20.351, 
                    9.624400000000001}, {20.057, 8.7184}, {21.959, 
                    8.101400000000002}, {22.317999999999998`, 
                    9.206400000000002}, {22.5, 10.3494}, {22.5, 11.5004}, {
                    22.5, 12.650400000000001`}, {22.317999999999998`, 
                    13.7944}, {21.959, 14.8984}}}]}, {
                   FaceForm[{
                    RGBColor[
                    0.9490000000000001, 0.9490000000000001, 
                    0.9490000000000001], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}}}, {{{11.5, 22.5}, {11.5, 20.5}, {13.404, 20.5}, {
                    15.231, 19.903}, {16.783, 18.773}, {17.961, 20.391}, {
                    16.064, 21.771}, {13.83, 22.5}, {11.5, 22.5}}}]}, {
                   FaceForm[{
                    RGBColor[0.929, 0.929, 0.929], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
                    0}, {1, 3, 3}}}, {{{17.9609, 20.3906}, {17.9609, 
                    20.3906}, {16.782899999999998`, 18.7736}, {
                    18.337899999999998`, 17.6416}, {19.4699, 16.0876}, {
                    20.0569, 14.2816}, {21.9589, 14.898599999999998`}, {
                    21.2409, 17.1096}, {19.857899999999997`, 
                    19.008599999999998`}, {17.9609, 20.3906}}}]}, {
                   FaceForm[{
                    RGBColor[0.722, 0.722, 0.722], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}}}, {{{6.2168, 4.2266}, {5.0388, 2.6096000000000004`}, {
                    6.9358, 1.2296000000000005`}, {9.1698, 
                    0.49960000000000004`}, {11.4998, 0.49960000000000004`}, {
                    11.4998, 2.4996000000000005`}, {9.5958, 
                    2.4996000000000005`}, {7.768800000000001, 
                    3.0966000000000005`}, {6.2168, 4.2266}}}]}, {
                   FaceForm[{
                    RGBColor[
                    0.7799999999999999, 0.7799999999999999, 
                    0.7799999999999999], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
                    0}}}, {{{16.783199999999997`, 4.2266}, {
                    15.231199999999998`, 3.0966000000000005`}, {
                    13.404199999999998`, 2.4996000000000005`}, {
                    11.500199999999996`, 2.4996000000000005`}, {
                    11.500199999999996`, 0.49960000000000004`}, {
                    13.830199999999998`, 0.49960000000000004`}, {
                    16.064199999999996`, 1.2296000000000005`}, {
                    17.961199999999998`, 2.6096000000000004`}, {
                    16.783199999999997`, 4.2266}}}]}, {
                   FaceForm[{
                    RGBColor[
                    0.8510000000000001, 0.8510000000000001, 
                    0.8510000000000001], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
                    0}}}, {{{20.0566, 8.718699999999998}, {19.4696, 
                    6.911699999999998}, {18.3376, 5.358699999999999}, {
                    16.7836, 4.226699999999998}, {17.9606, 
                    2.6096999999999984`}, {19.8586, 3.9906999999999986`}, {
                    21.2416, 5.890699999999999}, {21.9586, 
                    8.101699999999997}, {20.0566, 8.718699999999998}}}]}, {
                   FaceForm[{
                    RGBColor[
                    0.6749999999999999, 0.6749999999999999, 
                    0.6749999999999999], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}}}, {{{2.9434, 8.718699999999998}, {1.0414, 
                    8.101699999999997}, {1.7584, 5.890699999999999}, {3.1414, 
                    3.9906999999999986`}, {5.0394, 2.6096999999999984`}, {
                    6.2164, 4.226699999999998}, {4.6624, 5.358699999999999}, {
                    3.5304, 6.911699999999998}, {2.9434, 
                    8.718699999999998}}}]}, {
                   FaceForm[{
                    RGBColor[0.537, 0.537, 0.537], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{0, 2, 0}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}}}, {{{6.2168, 18.7734}, {5.0388, 20.3904}, {6.9358, 
                    21.7704}, {9.1698, 22.5004}, {11.4998, 22.5004}, {11.4998,
                     20.5004}, {9.5958, 20.5004}, {7.768800000000001, 
                    19.903399999999998`}, {6.2168, 18.7734}}}]}, {
                   FaceForm[{
                    RGBColor[0.584, 0.584, 0.584], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 
                    0}}}, {{{5.0391, 20.3906}, {3.1421, 
                    19.008599999999998`}, {1.7591, 17.1096}, {
                    1.0411000000000006`, 14.898599999999998`}, {
                    2.9431000000000007`, 14.2816}, {3.5301000000000005`, 
                    16.0876}, {4.662100000000001, 17.6416}, {6.2171, 
                    18.7736}, {5.0391, 20.3906}}}]}, {
                   FaceForm[{
                    RGBColor[0.631, 0.631, 0.631], 
                    Opacity[1.]}], 
                   
                   FilledCurveBox[{{{1, 4, 3}, {1, 3, 3}, {0, 1, 0}, {1, 3, 
                    3}, {1, 3, 3}, {0, 1, 0}}}, {{{1.041, 14.8984}, {
                    0.6819999999999999, 13.7944}, {0.4999999999999999, 
                    12.650400000000001`}, {0.4999999999999999, 11.5004}, {
                    0.4999999999999999, 10.3494}, {0.6819999999999999, 
                    9.206400000000002}, {1.041, 8.101400000000002}, {
                    2.9429999999999996`, 8.7184}, {2.649, 
                    9.624400000000001}, {2.5, 10.5594}, {2.5, 11.5004}, {2.5, 
                    12.4404}, {2.649, 13.3764}, {2.9429999999999996`, 
                    14.281400000000001`}, {1.041, 14.8984}}}]}}, AspectRatio -> 
                 Automatic, ImageSize -> {24., 24.}, 
                 PlotRange -> {{0., 24.}, {0., 24.}}], 
                GridBox[{{
                   RowBox[{
                    TagBox["\"Task UUID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"b8989b6d-8769-4b70-90d2-8689505fe959\"", 
                    "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox["\"Task environment: \"", "SummaryItemAnnotation"],
                     "\[InvisibleSpace]", 
                    TagBox["\"Session\"", "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox["\"Task type: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"Scheduled\"", "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox[
                    "\"Evaluation expression: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    TagBox[
                    RowBox[{"ExportScreenImage", "[", "]"}], Short], 
                    "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox["\"Run interval: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["15", "SummaryItem"]}]}, {
                   RowBox[{
                    TagBox["\"Total run count: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\[Infinity]", "SummaryItem"]}]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {
                  "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                 BaseStyle -> {
                  ShowStringCharacters -> False, NumberMarks -> False, 
                   PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
              GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
              AutoDelete -> False, 
              GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              BaselinePosition -> {1, 1}]}, 
           Dynamic[Typeset`open$$], ImageSize -> Automatic]}, "SummaryPanel"],
         DynamicModuleValues :> {}], 
       StyleBox["]", "NonInterpretableSummary"]}]},
    "CopyTag",
    DisplayFunction->(#& ),
    InterpretationFunction->(
     "TaskObject[<|TaskUUID -> b8989b6d-8769-4b70-90d2-8689505fe959, \
TaskEnvironment -> Session, TaskType -> Scheduled, <<3>>, \
HandlerFunctionsKeys -> {Task, TaskUUID, TaskType, TaskStatus, \
TaskEnvironment, HandlerFunctions, HandlerFunctionsKeys, EventName, \
EvaluationExpression, <<4>>, Re<<12>>unt, NextScheduledTime, TotalRunCount, \
MessageOutput, PrintOutput}, AutoRemove -> True|>]"& )],
   False,
   Editable->False,
   SelectWithContents->True,
   Selectable->False], "}"}]], "Output",
 CellChangeTimes->{3.8176081426236496`*^9},
 CellLabel->
  "Out[195]=",ExpressionUUID->"40170276-a1d5-46bf-9d0a-03af60e46ee3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Advent of Code in Wolfram Language", "Section",
 CellChangeTimes->{{3.817602417220108*^9, 
  3.8176024216168747`*^9}},ExpressionUUID->"09ab1934-74f9-429c-980e-\
769413ef9dfc"],

Cell[CellGroupData[{

Cell["Question 1", "Subsection",
 CellChangeTimes->{{3.8176029292106094`*^9, 
  3.8176029303136587`*^9}},ExpressionUUID->"c9e9fec9-6959-4b3d-9993-\
be61321c7dd7"],

Cell[BoxData[
 RowBox[{"SystemOpen", "[", "\"\<https://adventofcode.com\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.8176030208741965`*^9, 3.817603029328326*^9}, {
  3.817603378401868*^9, 3.817603379427125*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"81515197-5b2b-4a1f-8b47-37e6a4395dfb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"\"\<1721\n979\n366\n299\n675\n1456\>\"", "//", "StringSplit"}], "//",
   "ToExpression"}]], "Input",
 CellChangeTimes->{{3.8176034677917023`*^9, 3.817603476937828*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"8f4f9a2c-6ab5-4336-abe3-d8ad448a8239"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1721", ",", "979", ",", "366", ",", "299", ",", "675", ",", "1456"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.8176034771901536`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"3a6fda08-c0cf-4b94-b76f-38639ed8f964"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ClearAll", "@", "advent1"}], ";", 
  RowBox[{
   RowBox[{"advent1", "[", 
    RowBox[{"vals_", ",", 
     RowBox[{"n_", ":", "2"}]}], "]"}], ":=", 
   RowBox[{"Pick", "[", 
    RowBox[{"vals", ",", 
     RowBox[{"KnapsackSolve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"#", ",", "1", ",", "1"}], "}"}], "&"}], "/@", "vals"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"2020", ",", "2020", ",", "n"}], "}"}]}], "]"}], ",", "1"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8176042076051626`*^9, 3.817604212044005*^9}, {
   3.817604277975961*^9, 3.817604290584037*^9}, 3.8176043951143527`*^9},
 CellLabel->"In[42]:=",ExpressionUUID->"e64b3632-ed67-483d-945b-fab9da0acb11"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Times", "@@", 
  RowBox[{"{", 
   RowBox[{"3", ",", "4", ",", "2"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.8176043858870516`*^9, 3.8176043890844984`*^9}},
 CellLabel->"In[41]:=",ExpressionUUID->"92dd65a7-5c0a-4b6e-a29b-acd1574427a1"],

Cell[BoxData["24"], "Output",
 CellChangeTimes->{3.817604389420599*^9},
 CellLabel->"Out[41]=",ExpressionUUID->"8494bbc2-9183-4149-8ee8-d1ddc8b0000d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent1", "@", 
  RowBox[{"{", 
   RowBox[{
   "1721", ",", "979", ",", "366", ",", "299", ",", "675", ",", "1456"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.8176034900956383`*^9, 3.817603491240576*^9}, {
  3.8176035361190386`*^9, 3.8176035564096365`*^9}, {3.8176035866306553`*^9, 
  3.8176036306849675`*^9}, {3.817604201336668*^9, 3.817604218286663*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"3562818f-17da-4403-b532-fb5099255682"],

Cell[BoxData["514579"], "Output",
 CellChangeTimes->{
  3.817603556684901*^9, {3.8176035895677967`*^9, 3.8176036312481365`*^9}, 
   3.817604218577924*^9, 3.8176042922140293`*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"8802e990-7ffd-46ba-a14e-bd45aee7739f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent1", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1721", ",", "979", ",", "366", ",", "299", ",", "675", ",", "1456"}], 
    "}"}], ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.8176034900956383`*^9, 3.817603491240576*^9}, {
  3.8176035361190386`*^9, 3.8176035564096365`*^9}, {3.8176035866306553`*^9, 
  3.8176036306849675`*^9}, {3.817604201336668*^9, 3.817604218286663*^9}, {
  3.817604349733253*^9, 3.8176043521859818`*^9}},
 CellLabel->"In[40]:=",ExpressionUUID->"d7e962c6-2144-4516-aea3-a0d84094b185"],

Cell[BoxData["241861950"], "Output",
 CellChangeTimes->{3.817604352651746*^9},
 CellLabel->"Out[40]=",ExpressionUUID->"59014fc7-238b-4101-9a31-0e3d51198dae"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"session", "=", 
  RowBox[{"StartWebSession", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.817603650337143*^9, 3.8176036568666797`*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"53238441-ca6c-4024-a679-145c73e9a12e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GetAOCInput", "[", "url_", "]"}], ":=", 
  RowBox[{"StringReplace", "[", 
   RowBox[{
    RowBox[{"Last", "@", 
     RowBox[{"WebExecute", "[", 
      RowBox[{"session", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\"\<OpenPage\>\"", "\[Rule]", "url"}], ",", 
         "\"\<PageSource\>\""}], "}"}]}], "]"}]}], ",", 
    RowBox[{
     RowBox[{"\"\<<\>\"", "~~", 
      RowBox[{
       RowBox[{"Except", "[", "\"\<>\>\"", "]"}], ".."}], "~~", "\"\<>\>\""}],
      "\[Rule]", "\"\<\>\""}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.817605013945036*^9, 3.8176051463971157`*^9}},
 CellLabel->"In[60]:=",ExpressionUUID->"2c34f859-9171-47e1-b6fb-9d1d93dc528b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"WebExecute", "[", 
   RowBox[{"session", ",", 
    RowBox[{
    "\"\<OpenPage\>\"", "\[Rule]", 
     "\"\<https://adventofcode.com/2020/day/1/input\>\""}]}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.8176041410291147`*^9, 3.8176041576834707`*^9}, {
  3.8176043078573694`*^9, 3.817604312270934*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"0307294d-acc6-4d87-8d0d-afa56b9e585b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"input", "=", 
   RowBox[{"StringCases", "[", 
    RowBox[{
     RowBox[{"WebExecute", "[", 
      RowBox[{"session", ",", "\"\<PageSource\>\""}], "]"}], ",", 
     RowBox[{
      RowBox[{"d", ":", 
       RowBox[{"DigitCharacter", ".."}]}], "\[RuleDelayed]", 
      RowBox[{"ToExpression", "@", "d"}]}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.817603795600492*^9, 3.817603806046556*^9}, {
  3.817603922257759*^9, 3.8176039477607946`*^9}, {3.817604013343378*^9, 
  3.81760402399959*^9}, {3.817604174804313*^9, 3.8176041915858283`*^9}, {
  3.81760422902204*^9, 3.8176042302049313`*^9}, {3.8176043178579893`*^9, 
  3.817604320692407*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"06d71425-da00-4ac4-be28-264dfccc7197"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent1", "@", "input"}]], "Input",
 CellChangeTimes->{{3.8176043221235785`*^9, 3.8176043239896064`*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"ffdc6c4b-111c-441c-95d3-3243fc5a5b0d"],

Cell[BoxData["1014624"], "Output",
 CellChangeTimes->{3.817604324795431*^9},
 CellLabel->"Out[38]=",ExpressionUUID->"c171ae39-c3b8-4fda-9f0c-71b9706f87b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent1", "[", 
  RowBox[{"input", ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.817604325485589*^9, 3.817604327557047*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"d000d861-43b5-4e62-9fa7-83b63809c976"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1084", ",", "936"}], "}"}]], "Output",
 CellChangeTimes->{3.8176043279709387`*^9, 3.8176043974088864`*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"bdabae97-77d3-4381-9aee-1a0b7c93aa09"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"DeleteObject", "@", "session"}]], "Input",
 CellChangeTimes->{{3.8176040883455043`*^9, 3.8176040918351135`*^9}},
 CellLabel->"In[24]:=",ExpressionUUID->"30fca804-40fd-4e8c-be2e-5c4262c2fc82"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "@", "input"}]], "Input",
 CellChangeTimes->{{3.8176045122787905`*^9, 3.8176045134396887`*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"5bbcc0db-b826-4b32-a303-664dffd62c7b"],

Cell[BoxData["200"], "Output",
 CellChangeTimes->{3.817604513732904*^9},
 CellLabel->"Out[44]=",ExpressionUUID->"1eef6bbd-7af3-43f1-9ec5-8b45f98149ff"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "@", 
  RowBox[{"Subsets", "[", 
   RowBox[{"input", ",", 
    RowBox[{"{", "3", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.817604516299369*^9, 3.817604521924676*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"835c3248-326f-4265-8612-802e3eca72ed"],

Cell[BoxData["1313400"], "Output",
 CellChangeTimes->{3.8176045224348307`*^9},
 CellLabel->"Out[45]=",ExpressionUUID->"13773d17-9b40-4a50-8a07-8b7bf6fa4856"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Subsets", "[", 
    RowBox[{"input", ",", 
     RowBox[{"{", "3", "}"}]}], "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "@", "#"}], "\[Equal]", "2020"}], "&"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.817604525085249*^9, 3.817604549026281*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"9314552b-505b-4226-a304-549d628ee779"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"704", ",", "1223", ",", "93"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.8176045336446266`*^9, 3.817604553336384*^9}},
 CellLabel->"Out[47]=",ExpressionUUID->"808604a9-9fa7-4cc4-99d3-5e0e26e9d0c3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Times", "@@", 
  RowBox[{"First", "@", "%"}]}]], "Input",
 CellChangeTimes->{{3.817604555743003*^9, 3.8176045585567513`*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"4515c699-3953-4bd8-95b7-bdbe0362da7f"],

Cell[BoxData["80072256"], "Output",
 CellChangeTimes->{3.8176045590663815`*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"22e9ca08-6adc-46ff-bd07-a482cfaed0f4"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Question 2", "Subsection",
 CellChangeTimes->{{3.817604589613*^9, 
  3.8176045903734274`*^9}},ExpressionUUID->"67f20222-c8b5-4b71-8685-\
0db19a4b4c8b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"input2a", "=", 
  RowBox[{"StringSplit", "[", 
   RowBox[{
   "\"\<1-3 a: abcde\n1-3 b: cdefg\n2-9 c: ccccccccc\>\"", ",", 
    "\"\<\\n\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8176046543501086`*^9, 3.8176046646396832`*^9}, {
  3.8176048057603455`*^9, 3.817604807627161*^9}},
 CellLabel->"In[50]:=",ExpressionUUID->"0ada1e5e-f807-445c-965b-a4a067a3ce25"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"1-3 a: abcde\"\>", ",", "\<\"1-3 b: cdefg\"\>", 
   ",", "\<\"2-9 c: ccccccccc\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.8176046652629895`*^9, 3.81760480885789*^9},
 CellLabel->"Out[50]=",ExpressionUUID->"96262b4e-d91e-4ef1-b998-051b57866738"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"advent2", "[", "in_", "]"}], ":=", 
  RowBox[{"Length", "@", 
   RowBox[{"Select", "[", 
    RowBox[{"in", ",", 
     RowBox[{
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"s", "=", 
          RowBox[{"StringSplit", "[", 
           RowBox[{"#", ",", "\"\< \>\""}], "]"}]}], "}"}], ",", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"minmax", "=", 
            RowBox[{"ToExpression", "/@", 
             RowBox[{"StringSplit", "[", 
              RowBox[{
               RowBox[{"First", "@", "s"}], ",", "\"\<-\>\""}], "]"}]}]}], 
           "}"}], ",", 
          RowBox[{
           RowBox[{"First", "@", "minmax"}], "\[LessEqual]", 
           RowBox[{"Count", "[", 
            RowBox[{
             RowBox[{"Characters", "@", 
              RowBox[{"Last", "@", "s"}]}], ",", 
             RowBox[{"StringTake", "[", 
              RowBox[{
               RowBox[{
               "s", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               ",", "1"}], "]"}]}], "]"}], "\[LessEqual]", 
           RowBox[{"Last", "@", "minmax"}]}]}], "]"}]}], "]"}], "&"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.817604674827903*^9, 3.817604676085538*^9}, {
  3.817604779725814*^9, 3.8176048605485125`*^9}, {3.817604913256228*^9, 
  3.8176050027220397`*^9}, {3.817605197592452*^9, 3.817605205097381*^9}},
 CellLabel->"In[64]:=",ExpressionUUID->"f862e66e-1909-4810-bc66-44ae28470609"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent2", "@", "input2a"}]], "Input",
 CellChangeTimes->{{3.817605206488659*^9, 3.817605208852867*^9}},
 CellLabel->"In[65]:=",ExpressionUUID->"1fb6da1e-7df6-4129-a670-f29f0704c9a9"],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{3.817605209168948*^9},
 CellLabel->"Out[65]=",ExpressionUUID->"4b7d3e22-cd4e-4b76-8206-707592bd4e3c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent2", "@", "input2b"}]], "Input",
 CellChangeTimes->{{3.8176052096403885`*^9, 3.8176052125596066`*^9}},
 CellLabel->"In[66]:=",ExpressionUUID->"1a847c8f-012b-4972-a2a7-1ebec5169f03"],

Cell[BoxData["396"], "Output",
 CellChangeTimes->{3.8176052130044146`*^9},
 CellLabel->"Out[66]=",ExpressionUUID->"0d8b9def-42ea-4f67-b846-07d91d110674"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"input2b", "=", 
   RowBox[{"StringSplit", "[", 
    RowBox[{
     RowBox[{"StringTrim", "@", 
      RowBox[{
      "GetAOCInput", "[", "\"\<https://adventofcode.com/2020/day/2/input\>\"",
        "]"}]}], ",", "\"\<\\n\>\""}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.8176050382183304`*^9, 3.8176050418000865`*^9}, {
  3.8176051737054405`*^9, 3.817605192677602*^9}},
 CellLabel->"In[63]:=",ExpressionUUID->"b61326d0-2ffb-4c0a-bd10-47bc836812ae"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Characters", "[", "\"\<abcdeaaa\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.8176048692851753`*^9, 3.817604909196085*^9}},
 CellLabel->"In[55]:=",ExpressionUUID->"570d0480-86a9-49de-a8a2-4c00972e379f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"a\"\>", ",", "\<\"b\"\>", ",", "\<\"c\"\>", ",", "\<\"d\"\>", 
   ",", "\<\"e\"\>", ",", "\<\"a\"\>", ",", "\<\"a\"\>", ",", "\<\"a\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.8176048843817453`*^9, 3.817604909418491*^9}},
 CellLabel->"Out[55]=",ExpressionUUID->"53cd2f58-d480-47ff-9cab-72839827077f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"advent2b", "[", "in_", "]"}], ":=", 
  RowBox[{"Length", "@", 
   RowBox[{"Select", "[", 
    RowBox[{"in", ",", 
     RowBox[{
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"s", "=", 
          RowBox[{"StringSplit", "[", 
           RowBox[{"#", ",", "\"\< \>\""}], "]"}]}], "}"}], ",", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"yesno", "=", 
            RowBox[{"ToExpression", "/@", 
             RowBox[{"StringSplit", "[", 
              RowBox[{
               RowBox[{"First", "@", "s"}], ",", "\"\<-\>\""}], "]"}]}]}], 
           "}"}], ",", 
          RowBox[{
           RowBox[{"Count", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Characters", "[", 
               RowBox[{"Last", "@", "s"}], "]"}], "\[LeftDoubleBracket]", 
              "yesno", "\[RightDoubleBracket]"}], ",", 
             RowBox[{"StringTake", "[", 
              RowBox[{
               RowBox[{
               "s", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               ",", "1"}], "]"}]}], "]"}], "\[Equal]", "1"}]}], "]"}]}], 
       "]"}], "&"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.817605268672033*^9, 3.817605337974334*^9}, {
  3.81760537384905*^9, 3.8176053741602106`*^9}},
 CellLabel->"In[71]:=",ExpressionUUID->"a8fe9417-34a0-477f-943c-5c2b2b421a94"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent2b", "[", "input2a", "]"}]], "Input",
 CellChangeTimes->{{3.817605339244933*^9, 3.81760534288721*^9}},
 CellLabel->"In[72]:=",ExpressionUUID->"c682ded0-d8a0-4c2d-9118-678d98285782"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.817605343190399*^9, 3.8176053754442754`*^9},
 CellLabel->"Out[72]=",ExpressionUUID->"f23551e0-0a9d-4df2-b9d5-1178489889cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent2b", "[", "input2b", "]"}]], "Input",
 CellChangeTimes->{{3.817605339244933*^9, 3.81760534288721*^9}, {
  3.81760538537963*^9, 3.817605386132616*^9}},
 CellLabel->"In[73]:=",ExpressionUUID->"c08c69b1-508c-4ae2-a76f-a67a6d4979cf"],

Cell[BoxData["428"], "Output",
 CellChangeTimes->{3.817605386469513*^9},
 CellLabel->"Out[73]=",ExpressionUUID->"91f475da-a4aa-4aa0-b325-0990b418cb21"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Question 3", "Subsection",
 CellChangeTimes->{{3.8176054177081585`*^9, 
  3.817605418615733*^9}},ExpressionUUID->"b081776a-d67c-4e72-8d87-\
209becffc835"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"input3a", "=", 
  RowBox[{"Characters", "/@", 
   RowBox[{
   "StringSplit", "@", 
    "\"\<..##.......\n#...#...#..\n.#....#..#.\n..#.#...#.#\n.#...##..#.\n\
..#.##.....\n.#.#.#....#\n.#........#\n#.##...#...\n#...##....#\n\
.#..#...#.#\>\""}]}]}]], "Input",
 CellChangeTimes->{{3.817605436979248*^9, 3.817605452327876*^9}},
 CellLabel->"In[75]:=",ExpressionUUID->"8475b5ab-33b8-4b40-8c81-40c5840228f7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\".\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\"#\"\>",
      ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", 
     ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>",
      ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", 
     ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>",
      ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>", 
     ",", "\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\".\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>",
      ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", 
     ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>",
      ",", "\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>", 
     ",", "\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\".\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>",
      ",", "\<\"#\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", 
     ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>",
      ",", "\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", 
     ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>",
      ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", 
     ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\"#\"\>",
      ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>", 
     ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>",
      ",", "\<\"#\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", 
     ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\".\"\>", ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>",
      ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", ",", "\<\".\"\>", 
     ",", "\<\"#\"\>", ",", "\<\".\"\>", ",", "\<\"#\"\>"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.817605445467444*^9, 3.8176054533112373`*^9}},
 CellLabel->"Out[75]=",ExpressionUUID->"e5b8ae80-a6d8-4047-9dc8-ad300339cfc5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"1", "+", 
     RowBox[{"Mod", "[", 
      RowBox[{
       RowBox[{"#", "-", "1", "+", "3"}], ",", 
       RowBox[{"Length", "@", 
        RowBox[{"First", "@", "input3a"}]}]}], "]"}]}], "&"}], ",", "1", ",", 
   RowBox[{"Length", "@", "input3a"}]}], "]"}]], "Input",
 CellLabel->"In[83]:=",ExpressionUUID->"66c151de-926f-4097-97ac-cb68570f6b57"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "4", ",", "7", ",", "10", ",", "2", ",", "5", ",", "8", ",", "11",
    ",", "3", ",", "6", ",", "9", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.8176057124898767`*^9},
 CellLabel->"Out[83]=",ExpressionUUID->"d9c27b43-c7ea-4e31-a1b0-4340001a3649"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "@", "%"}]], "Input",
 CellChangeTimes->{{3.817605714915589*^9, 3.8176057157423773`*^9}},
 CellLabel->"In[84]:=",ExpressionUUID->"f926cd68-3716-4fdd-84da-2d3bbaeb322d"],

Cell[BoxData["12"], "Output",
 CellChangeTimes->{3.8176057158650713`*^9},
 CellLabel->"Out[84]=",ExpressionUUID->"f8de8db0-c370-48fa-8a3c-d5cee13c489b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"advent3a", "[", "in_", "]"}], ":=", 
  RowBox[{"Count", "[", 
   RowBox[{
    RowBox[{"Extract", "[", 
     RowBox[{"in", ",", 
      RowBox[{"MapIndexed", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"First", "@", "#2"}], ",", "#"}], "}"}], "&"}], ",", 
        RowBox[{"Most", "@", 
         RowBox[{"NestList", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "+", 
             RowBox[{"Mod", "[", 
              RowBox[{
               RowBox[{"#", "-", "1", "+", "3"}], ",", 
               RowBox[{"Length", "@", 
                RowBox[{"First", "@", "in"}]}]}], "]"}]}], "&"}], ",", "1", 
           ",", 
           RowBox[{"Length", "@", "in"}]}], "]"}]}]}], "]"}]}], "]"}], ",", 
    "\"\<#\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8176055170816927`*^9, 3.817605688765088*^9}, {
  3.8176057255842333`*^9, 3.8176057577179456`*^9}},
 CellLabel->"In[88]:=",ExpressionUUID->"24ef65f1-e424-468e-8362-e024ec156ca9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent3a", "@", "input3a"}]], "Input",
 CellChangeTimes->{{3.8176057601325283`*^9, 3.8176057630335197`*^9}},
 CellLabel->"In[89]:=",ExpressionUUID->"5aced434-9e0e-4f0d-b034-caed485e8ca7"],

Cell[BoxData["7"], "Output",
 CellChangeTimes->{3.8176057633436904`*^9},
 CellLabel->"Out[89]=",ExpressionUUID->"0f1c09f6-fc68-4f79-a540-6b73ef454cb2"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"input3b", "=", 
   RowBox[{"Characters", "/@", 
    RowBox[{"StringSplit", "@", 
     RowBox[{
     "GetAOCInput", "[", "\"\<https://adventofcode.com/2020/day/3/input\>\"", 
      "]"}]}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.817605768273596*^9, 3.817605792516965*^9}},
 CellLabel->"In[91]:=",ExpressionUUID->"e04b9fa9-8d88-4005-81c7-acdfa33f1fe6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "@", "input3b"}]], "Input",
 CellChangeTimes->{{3.8176056912295265`*^9, 3.817605693507293*^9}, {
  3.8176057956030035`*^9, 3.817605795693755*^9}},
 CellLabel->"In[92]:=",ExpressionUUID->"b6815dbf-6c0a-4473-86a9-faee3ecd24ef"],

Cell[BoxData["323"], "Output",
 CellChangeTimes->{3.817605693801506*^9, 3.8176057959763722`*^9},
 CellLabel->"Out[92]=",ExpressionUUID->"6277a593-d11d-454f-9cd0-a48b1a9dab02"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent3a", "[", "input3b", "]"}]], "Input",
 CellChangeTimes->{{3.8176057975589476`*^9, 3.8176058009271345`*^9}},
 CellLabel->"In[93]:=",ExpressionUUID->"925c89c3-8153-45e4-8282-00972a5553b1"],

Cell[BoxData["211"], "Output",
 CellChangeTimes->{3.817605801380398*^9},
 CellLabel->"Out[93]=",ExpressionUUID->"f1d7a393-f2d2-4941-8cfc-ab90ed84b998"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"advent3a", "[", 
   RowBox[{"in_", ",", 
    RowBox[{"right_", ":", "3"}]}], "]"}], ":=", 
  RowBox[{"Count", "[", 
   RowBox[{
    RowBox[{"Extract", "[", 
     RowBox[{"in", ",", 
      RowBox[{"MapIndexed", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"First", "@", "#2"}], ",", "#"}], "}"}], "&"}], ",", 
        RowBox[{"Most", "@", 
         RowBox[{"NestList", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "+", 
             RowBox[{"Mod", "[", 
              RowBox[{
               RowBox[{"#", "-", "1", "+", "right"}], ",", 
               RowBox[{"Length", "@", 
                RowBox[{"First", "@", "in"}]}]}], "]"}]}], "&"}], ",", "1", 
           ",", 
           RowBox[{"Length", "@", "in"}]}], "]"}]}]}], "]"}]}], "]"}], ",", 
    "\"\<#\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8176058294022474`*^9, 3.8176058502637706`*^9}},
 CellLabel->"In[94]:=",ExpressionUUID->"27adf3ee-e3eb-4a5a-bf96-e3b3b33a9b6c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"advent3a", "[", 
    RowBox[{"input3a", ",", "#"}], "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{"1", ",", "3", ",", "5", ",", "7"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.817605852895403*^9, 3.817605870195281*^9}},
 CellLabel->"In[95]:=",ExpressionUUID->"a34141bc-5177-4356-89c8-7a7f07279015"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "7", ",", "3", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->{3.8176058704196806`*^9},
 CellLabel->"Out[95]=",ExpressionUUID->"2630fde9-d4cc-4bd3-896a-474fe819eae7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent3a", "[", 
  RowBox[{
   RowBox[{"input3a", "\[LeftDoubleBracket]", 
    RowBox[{";;", ";;", "2"}], "\[RightDoubleBracket]"}], ",", "1"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.817605877851553*^9, 3.8176058955497227`*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"c7661930-9dd0-425d-beba-0d39686ba08e"],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{{3.81760588954607*^9, 3.817605895786086*^9}},
 CellLabel->"Out[97]=",ExpressionUUID->"b584e7b7-f59a-4e46-8fa9-d5eab68b6e28"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"advent3b", "[", "in_", "]"}], ":=", 
  RowBox[{"Times", "@@", 
   RowBox[{"Append", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"advent3a", "[", 
        RowBox[{"in", ",", "#"}], "]"}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3", ",", "5", ",", "7"}], "}"}]}], ",", 
     RowBox[{"advent3a", "[", 
      RowBox[{
       RowBox[{"in", "\[LeftDoubleBracket]", 
        RowBox[{";;", ";;", "2"}], "\[RightDoubleBracket]"}], ",", "1"}], 
      "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8176059001589947`*^9, 3.8176059250605164`*^9}},
 CellLabel->"In[98]:=",ExpressionUUID->"34df91bf-4e7e-470a-9787-99c5918f30b9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent3b", "[", "input3a", "]"}]], "Input",
 CellChangeTimes->{{3.817605925839433*^9, 3.817605929214407*^9}},
 CellLabel->"In[99]:=",ExpressionUUID->"f827f21c-2d6c-4ae7-8fb9-f4c16d709c6b"],

Cell[BoxData["336"], "Output",
 CellChangeTimes->{3.8176059294976482`*^9},
 CellLabel->"Out[99]=",ExpressionUUID->"d0fd1b31-9551-4965-9ee2-d9d71a267f69"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent3b", "[", "input3b", "]"}]], "Input",
 CellChangeTimes->{{3.817605925839433*^9, 3.8176059340445232`*^9}},
 CellLabel->
  "In[100]:=",ExpressionUUID->"6570df4d-05b7-45aa-8e40-b0d53530bb43"],

Cell[BoxData["3584591857"], "Output",
 CellChangeTimes->{3.8176059343965816`*^9},
 CellLabel->
  "Out[100]=",ExpressionUUID->"f8c48c67-6701-426f-a1f1-f52c5ffca1a9"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Question 4", "Subsection",
 CellChangeTimes->{{3.8176059493745794`*^9, 
  3.8176059506460266`*^9}},ExpressionUUID->"47bf3f43-e4f5-4f87-a0bf-\
1da373ed2e8f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"input4a", "=", 
  RowBox[{"StringSplit", "[", 
   RowBox[{
   "\"\<ecl:gry pid:860033327 eyr:2020 hcl:#fffffd\nbyr:1937 iyr:2017 cid:147 \
hgt:183cm\n\niyr:2013 ecl:amb cid:350 eyr:2023 pid:028048884\nhcl:#cfa07d \
byr:1929\n\nhcl:#ae17e1 iyr:2013\neyr:2024\necl:brn pid:760753108 byr:1931\n\
hgt:179cm\n\nhcl:#cfa07d eyr:2025 pid:166559648\niyr:2011 ecl:brn \
hgt:59in\>\"", ",", "\"\<\\n\\n\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.817605990633281*^9, 3.8176060052785645`*^9}},
 CellLabel->
  "In[101]:=",ExpressionUUID->"ecde275d-0e96-4870-9b48-e33ee9f3d11d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ecl:gry pid:860033327 eyr:2020 hcl:#fffffd\\nbyr:1937 iyr:2017 \
cid:147 hgt:183cm\"\>", 
   ",", "\<\"iyr:2013 ecl:amb cid:350 eyr:2023 pid:028048884\\nhcl:#cfa07d \
byr:1929\"\>", 
   ",", "\<\"hcl:#ae17e1 iyr:2013\\neyr:2024\\necl:brn pid:760753108 byr:1931\
\\nhgt:179cm\"\>", 
   ",", "\<\"hcl:#cfa07d eyr:2025 pid:166559648\\niyr:2011 ecl:brn hgt:59in\"\
\>"}], "}"}]], "Output",
 CellChangeTimes->{3.817606006274897*^9},
 CellLabel->
  "Out[101]=",ExpressionUUID->"8da5847d-18a1-43c2-b4cf-df5fb628bac6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fields", "=", 
  RowBox[{"StringCases", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"id", ":", 
      RowBox[{"Repeated", "[", 
       RowBox[{"LetterCharacter", ",", 
        RowBox[{"{", "3", "}"}]}], "]"}]}], "~~", "\"\<:\>\""}], 
    "\[RuleDelayed]", "id"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8176061540492983`*^9, 3.817606163719746*^9}},
 CellLabel->
  "In[106]:=",ExpressionUUID->"4d1489fc-5dd3-4aea-af43-ab803ece2712"],

Cell[BoxData[
 RowBox[{"StringCases", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"id", ":", 
     RowBox[{"Repeated", "[", 
      RowBox[{"LetterCharacter", ",", 
       RowBox[{"{", "3", "}"}]}], "]"}]}], "~~", "\<\":\"\>"}], 
   "\[RuleDelayed]", "id"}], "]"}]], "Output",
 CellChangeTimes->{3.817606169452652*^9},
 CellLabel->
  "Out[106]=",ExpressionUUID->"efb02205-6b7b-4126-a844-c598382e0c3e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Union", "@", 
  RowBox[{"Flatten", "@", 
   RowBox[{"fields", "[", "input4a", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8176060675732994`*^9, 3.817606109510967*^9}, {
  3.817606172864447*^9, 3.8176061749243636`*^9}},
 CellLabel->
  "In[107]:=",ExpressionUUID->"8197903b-7ae5-4924-a89f-647f27661660"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"byr\"\>", ",", "\<\"cid\"\>", ",", "\<\"ecl\"\>", 
   ",", "\<\"eyr\"\>", ",", "\<\"hcl\"\>", ",", "\<\"hgt\"\>", 
   ",", "\<\"iyr\"\>", ",", "\<\"pid\"\>"}], "}"}]], "Output",
 CellChangeTimes->{{3.8176060941253705`*^9, 3.817606109739375*^9}, 
   3.817606175222565*^9},
 CellLabel->
  "Out[107]=",ExpressionUUID->"4a52248d-1f2e-41fb-8cfc-1e187f5eca58"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "@", 
  RowBox[{"Select", "[", 
   RowBox[{"input4a", ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "@", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{
         RowBox[{"Union", "@", 
          RowBox[{"fields", "@", "#"}]}], ",", "\"\<cid\>\""}], "]"}]}], 
      "\[Equal]", "7"}], "&"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.81760617651112*^9, 3.8176062081778097`*^9}},
 CellLabel->
  "In[110]:=",ExpressionUUID->"39fc329d-102b-42ec-ad77-22050b1c62ba"],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{{3.817606179531041*^9, 3.8176062083264103`*^9}},
 CellLabel->
  "Out[110]=",ExpressionUUID->"6ccd86df-ea32-4c1f-9c4a-76a0a0cf2b05"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "@", 
  RowBox[{"Select", "[", 
   RowBox[{"input4b", ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "@", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{
         RowBox[{"Union", "@", 
          RowBox[{"fields", "@", "#"}]}], ",", "\"\<cid\>\""}], "]"}]}], 
      "\[Equal]", "7"}], "&"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.81760617651112*^9, 3.8176062357310133`*^9}},
 CellLabel->
  "In[112]:=",ExpressionUUID->"a3eff975-ff6a-48f7-b12c-de039709744f"],

Cell[BoxData["242"], "Output",
 CellChangeTimes->{3.8176062367183695`*^9},
 CellLabel->
  "Out[112]=",ExpressionUUID->"d9e50b17-c5ec-4db4-b4ca-8a7024e0244a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"input4b", "=", 
   RowBox[{"StringSplit", "[", 
    RowBox[{
     RowBox[{
     "GetAOCInput", "[", "\"\<https://adventofcode.com/2020/day/4/input\>\"", 
      "]"}], ",", "\"\<\\n\\n\>\""}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.817606214779682*^9, 3.8176062274072695`*^9}},
 CellLabel->
  "In[111]:=",ExpressionUUID->"4d6951e4-688a-49e4-b33f-08e42745ce10"],

Cell[BoxData["String"], "Input",
 CellChangeTimes->{{3.81760613308709*^9, 
  3.817606139251812*^9}},ExpressionUUID->"38648cf1-a1f3-4a34-a3c0-\
c5d5c8f38028"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fieldvalues", "=", 
  RowBox[{"StringCases", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"id", ":", 
      RowBox[{"Repeated", "[", 
       RowBox[{"LetterCharacter", ",", 
        RowBox[{"{", "3", "}"}]}], "]"}]}], "~~", "\"\<:\>\"", "~~", 
     RowBox[{"val", ":", 
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"\"\< \>\"", "|", "\"\<\\n\>\""}], "]"}], ".."}]}]}], 
    "\[RuleDelayed]", 
    RowBox[{"(", 
     RowBox[{"id", "\[Rule]", "val"}], ")"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.817606287958584*^9, 3.8176064217043486`*^9}},
 CellLabel->
  "In[123]:=",ExpressionUUID->"43635550-bb64-49c4-b0a9-5e95bafeb53f"],

Cell[BoxData[
 RowBox[{"StringCases", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"id", ":", 
     RowBox[{"Repeated", "[", 
      RowBox[{"LetterCharacter", ",", 
       RowBox[{"{", "3", "}"}]}], "]"}]}], "~~", "\<\":\"\>", "~~", 
    RowBox[{"val", ":", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"\<\" \"\>", "|", "\<\"\\n\"\>"}], "]"}], ".."}], ")"}]}]}], 
   "\[RuleDelayed]", 
   RowBox[{"id", "\[Rule]", "val"}]}], "]"}]], "Output",
 CellChangeTimes->{{3.8176063449812107`*^9, 3.817606421942706*^9}},
 CellLabel->
  "Out[123]=",ExpressionUUID->"c91011e7-7c87-43af-8dff-616900656f05"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"test", "=", 
  RowBox[{"fieldvalues", "[", 
   RowBox[{"First", "@", "input4a"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.817606345868491*^9, 3.8176063502877455`*^9}, {
  3.817606498013425*^9, 3.8176064983934183`*^9}},
 CellLabel->
  "In[126]:=",ExpressionUUID->"c61e2749-25cb-4224-a390-9af30e0cc211"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"ecl\"\>", "\[Rule]", "\<\"gry\"\>"}], ",", 
   RowBox[{"\<\"pid\"\>", "\[Rule]", "\<\"860033327\"\>"}], ",", 
   RowBox[{"\<\"eyr\"\>", "\[Rule]", "\<\"2020\"\>"}], ",", 
   RowBox[{"\<\"hcl\"\>", "\[Rule]", "\<\"#fffffd\"\>"}], ",", 
   RowBox[{"\<\"byr\"\>", "\[Rule]", "\<\"1937\"\>"}], ",", 
   RowBox[{"\<\"iyr\"\>", "\[Rule]", "\<\"2017\"\>"}], ",", 
   RowBox[{"\<\"cid\"\>", "\[Rule]", "\<\"147\"\>"}], ",", 
   RowBox[{"\<\"hgt\"\>", "\[Rule]", "\<\"183cm\"\>"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.8176063505679965`*^9, 3.8176064225521994`*^9}, 
   3.8176064988143005`*^9},
 CellLabel->
  "Out[126]=",ExpressionUUID->"6f0e9aa2-2655-4504-8c0e-4ab8e4ce016f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"rules", "=", 
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{"\"\<byr\>\"", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"DigitCharacter", ",", 
           RowBox[{"{", "4", "}"}]}], "]"}]}], "/;", 
        RowBox[{"1920", "\[LessEqual]", 
         RowBox[{"ToExpression", "@", "d"}], "\[LessEqual]", "2002"}]}], 
       ")"}]}], ",", 
     RowBox[{"\"\<iyr\>\"", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"DigitCharacter", ",", 
           RowBox[{"{", "4", "}"}]}], "]"}]}], "/;", 
        RowBox[{"2010", "\[LessEqual]", 
         RowBox[{"ToExpression", "@", "d"}], "\[LessEqual]", "2020"}]}], 
       ")"}]}], ",", 
     RowBox[{"\"\<eyr\>\"", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"DigitCharacter", ",", 
           RowBox[{"{", "4", "}"}]}], "]"}]}], "/;", 
        RowBox[{"2020", "\[LessEqual]", 
         RowBox[{"ToExpression", "@", "d"}], "\[LessEqual]", "2030"}]}], 
       ")"}]}], ",", 
     RowBox[{"\"\<hgt\>\"", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"d", ":", 
          RowBox[{"DigitCharacter", ".."}]}], "~~", 
         RowBox[{"w", ":", 
          RowBox[{"\"\<cm\>\"", "|", "\"\<in\>\""}]}]}], "/;", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"w", "\[Equal]", "\"\<cm\>\""}], ",", 
          RowBox[{"150", "\[LessEqual]", 
           RowBox[{"ToExpression", "@", "d"}], "\[LessEqual]", "193"}], ",", 
          RowBox[{"59", "\[LessEqual]", 
           RowBox[{"ToExpression", "@", "d"}], "\[LessEqual]", "76"}]}], 
         "]"}]}], ")"}]}], ",", 
     RowBox[{"\"\<hcl\>\"", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"\"\<#\>\"", "~~", 
        RowBox[{"Repeated", "[", 
         RowBox[{
          RowBox[{"Alternatives", "@@", 
           RowBox[{"Prepend", "[", 
            RowBox[{
             RowBox[{"CharacterRange", "[", 
              RowBox[{"\"\<a\>\"", ",", "\"\<f\>\""}], "]"}], ",", 
             "DigitCharacter"}], "]"}]}], ",", 
          RowBox[{"{", "6", "}"}]}], "]"}]}], ")"}]}], ",", 
     RowBox[{"\"\<ecl\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<amb\>\"", ",", "\"\<blu\>\"", ",", "\"\<brn\>\"", ",", 
        "\"\<gry\>\"", ",", "\"\<grn\>\"", ",", "\"\<hzl\>\"", ",", 
        "\"\<oth\>\""}], "}"}]}], ",", 
     RowBox[{"\"\<pid\>\"", "\[Rule]", 
      RowBox[{"Repeated", "[", 
       RowBox[{"DigitCharacter", ",", 
        RowBox[{"{", "9", "}"}]}], "]"}]}]}], "\[RightAssociation]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.8176064401910534`*^9, 3.817606491225009*^9}, {
  3.817606579492461*^9, 3.817606805419183*^9}},
 CellLabel->
  "In[137]:=",ExpressionUUID->"b88ae840-a77b-42cd-9ae8-1e5b687e6e24"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StringMatchQ", "[", 
    RowBox[{"#1", ",", "#2"}], "]"}], "&"}], "@@@", 
  RowBox[{"Select", "[", 
   RowBox[{
    RowBox[{"Merge", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"KeyDrop", "[", 
         RowBox[{
          RowBox[{"Association", "@", "test"}], ",", "\"\<cid\>\""}], "]"}], 
        ",", "rules"}], "}"}], ",", "Identity"}], "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "@", "#"}], "\[Equal]", "2"}], "&"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.817606503295295*^9, 3.8176065710149403`*^9}},
 CellLabel->
  "In[138]:=",ExpressionUUID->"0582b6b8-e3be-419c-b306-7e8a2f1ae711"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"ecl\"\>", "\[Rule]", "True"}], ",", 
   RowBox[{"\<\"pid\"\>", "\[Rule]", "True"}], ",", 
   RowBox[{"\<\"eyr\"\>", "\[Rule]", "True"}], ",", 
   RowBox[{"\<\"hcl\"\>", "\[Rule]", "True"}], ",", 
   RowBox[{"\<\"byr\"\>", "\[Rule]", "True"}], ",", 
   RowBox[{"\<\"iyr\"\>", "\[Rule]", "True"}], ",", 
   RowBox[{"\<\"hgt\"\>", "\[Rule]", "True"}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.8176065163741493`*^9, {3.817606554404922*^9, 3.817606581474121*^9}, 
   3.817606810859284*^9},
 CellLabel->
  "Out[138]=",ExpressionUUID->"7682aaaf-2024-4935-a873-d44c26e4ae5e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"input3avalid", "=", 
   RowBox[{"StringSplit", "[", 
    RowBox[{
    "\"\<pid:087499704 hgt:74in ecl:grn iyr:2012 eyr:2030 byr:1980\n\
hcl:#623a2f\n\neyr:2029 ecl:blu cid:129 byr:1989\niyr:2014 pid:896056539 \
hcl:#a97842 hgt:165cm\n\nhcl:#888785\nhgt:164cm byr:2001 iyr:2015 cid:88\n\
pid:545766238 ecl:hzl\neyr:2022\n\niyr:2010 hgt:158cm hcl:#b6652a ecl:blu \
byr:1944 eyr:2021 pid:093154719\>\"", ",", "\"\<\\n\\n\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.817606830013957*^9, 3.817606844489213*^9}},
 CellLabel->
  "In[139]:=",ExpressionUUID->"22a81657-1529-4f33-9459-88989d6aa94f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"input3ainvalid", "=", 
   RowBox[{"StringSplit", "[", 
    RowBox[{
    "\"\<eyr:1972 cid:100\nhcl:#18171d ecl:amb hgt:170 pid:186cm iyr:2018 \
byr:1926\n\niyr:2019\nhcl:#602927 eyr:1967 hgt:170cm\necl:grn pid:012533040 \
byr:1946\n\nhcl:dab227 iyr:2012\necl:brn hgt:182cm pid:021572410 eyr:2020 \
byr:1992 cid:277\n\nhgt:59cm ecl:zzz\neyr:2038 hcl:74454a iyr:2023\n\
pid:3556412378 byr:2007\>\"", ",", "\"\<\\n\\n\>\""}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.8176069259682293`*^9, 3.8176069353180923`*^9}},
 CellLabel->
  "In[143]:=",ExpressionUUID->"79008b19-c89f-4db4-86c2-ac298e0fb4dc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", "True", "}"}], "===", 
    RowBox[{"Union", "@", 
     RowBox[{"Values", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"StringMatchQ", "[", 
         RowBox[{"#1", ",", "#2"}], "]"}], "&"}], "@@@", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Merge", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"KeyDrop", "[", 
              RowBox[{
               RowBox[{"Association", "@", 
                RowBox[{"fieldvalues", "@", "#"}]}], ",", "\"\<cid\>\""}], 
              "]"}], ",", "rules"}], "}"}], ",", "Identity"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "@", "#"}], "\[Equal]", "2"}], "&"}]}], "]"}]}], 
      "]"}]}]}], "&"}], "/@", "input3ainvalid"}]], "Input",
 CellChangeTimes->{{3.8176068604501743`*^9, 3.81760694017211*^9}},
 CellLabel->
  "In[144]:=",ExpressionUUID->"1873585f-1986-48a1-85e8-738d30ad6249"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"False", ",", "False", ",", "False", ",", "False"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.817606874445*^9, 3.8176069407931614`*^9}},
 CellLabel->
  "Out[144]=",ExpressionUUID->"f475e4de-f733-42d3-b209-b741433657a9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"{", "True", "}"}], "===", 
     RowBox[{"Union", "@", 
      RowBox[{"Values", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"StringMatchQ", "[", 
          RowBox[{"#1", ",", "#2"}], "]"}], "&"}], "@@@", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Merge", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"KeyDrop", "[", 
               RowBox[{
                RowBox[{"Association", "@", 
                 RowBox[{"fieldvalues", "@", "#"}]}], ",", "\"\<cid\>\""}], 
               "]"}], ",", "rules"}], "}"}], ",", "Identity"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "@", "#"}], "\[Equal]", "2"}], "&"}]}], "]"}]}],
        "]"}]}]}], "&"}], "/@", "input4b"}], "//", "Counts"}]], "Input",
 CellChangeTimes->{{3.8176068604501743`*^9, 3.817606949052638*^9}, {
  3.8176069839914355`*^9, 3.8176069841300683`*^9}},
 CellLabel->
  "In[148]:=",ExpressionUUID->"79689c1f-afaa-4221-9081-c36994e31386"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"False", "\[Rule]", "70"}], ",", 
   RowBox[{"True", "\[Rule]", "216"}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{3.8176069498096147`*^9, 3.8176069852997046`*^9},
 CellLabel->
  "Out[148]=",ExpressionUUID->"dde4a73e-431e-4668-9098-7579b4224413"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"input4b", "\[LeftDoubleBracket]", 
  RowBox[{"{", 
   RowBox[{"1", ",", 
    RowBox[{"-", "1"}]}], "}"}], "\[RightDoubleBracket]"}]], "Input",
 CellChangeTimes->{{3.8176069725772247`*^9, 3.8176070060358133`*^9}},
 CellLabel->
  "In[149]:=",ExpressionUUID->"b60b459d-b4c5-412b-b4b3-cb829c3a1449"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"byr:1971\\neyr:2039\\nhgt:172in pid:170cm hcl:17106b iyr:2012 \
ecl:gry\\ncid:339\"\>", 
   ",", "\<\"ecl:brn eyr:2026 iyr:2017 hgt:75in\\npid:745302991 byr:1969 \
hcl:#7394c7\\n\"\>"}], "}"}]], "Output",
 CellChangeTimes->{{3.817606975152299*^9, 3.817607006262206*^9}},
 CellLabel->
  "Out[149]=",ExpressionUUID->"ef251e81-8246-43ee-bb7a-62d0f219383e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Select", "[", 
   RowBox[{
    RowBox[{"StringReplace", "[", 
     RowBox[{"input4b", ",", 
      RowBox[{"\"\<\\n\>\"", "\[Rule]", "\"\< \>\""}]}], "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"\[LeftAssociation]", 
       RowBox[{"True", "\[Rule]", "7"}], "\[RightAssociation]"}], "===", 
      RowBox[{"Counts", "@", 
       RowBox[{"Values", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"StringMatchQ", "[", 
           RowBox[{"#1", ",", "#2"}], "]"}], "&"}], "@@@", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Merge", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"KeyDrop", "[", 
                RowBox[{
                 RowBox[{"Association", "@", 
                  RowBox[{"fieldvalues", "@", "#"}]}], ",", "\"\<cid\>\""}], 
                "]"}], ",", "rules"}], "}"}], ",", "Identity"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "@", "#"}], "\[Equal]", "2"}], "&"}]}], 
          "]"}]}], "]"}]}]}], "&"}]}], "]"}], "//", "Length"}]], "Input",
 CellChangeTimes->{{3.8176070982289624`*^9, 3.8176071798652954`*^9}, {
  3.8176072849113655`*^9, 3.8176073017174683`*^9}},
 CellLabel->
  "In[155]:=",ExpressionUUID->"5b540469-a344-45ea-ac26-450a8298c718"],

Cell[BoxData["186"], "Output",
 CellChangeTimes->{{3.8176071052942324`*^9, 3.8176071803230705`*^9}, 
   3.8176073020876613`*^9},
 CellLabel->
  "Out[155]=",ExpressionUUID->"5d201107-417e-4a34-9e0a-c2d1512cadf3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Question 5", "Subsection",
 CellChangeTimes->{{3.817607315678536*^9, 
  3.8176073167247405`*^9}},ExpressionUUID->"09b913ed-2feb-49e5-9e77-\
70c412e9d1ea"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Log", "[", 
  RowBox[{"2", ",", "128"}], "]"}]], "Input",
 CellChangeTimes->{{3.8176073881180935`*^9, 3.8176073919827204`*^9}},
 CellLabel->
  "In[156]:=",ExpressionUUID->"8862db79-9d5f-43ed-acde-ce7fe646ebd5"],

Cell[BoxData["7"], "Output",
 CellChangeTimes->{3.817607392217094*^9},
 CellLabel->
  "Out[156]=",ExpressionUUID->"6a85eacc-424a-457d-a08a-7b37781340f4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"advent5", "[", "in_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"FromDigits", "[", 
         RowBox[{"#", ",", "2"}], "]"}], "&"}], "/@", 
       RowBox[{"TakeDrop", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Characters", "[", "in", "]"}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"\"\<F\>\"", "|", "\"\<L\>\""}], "\[Rule]", "0"}], ",", 
            RowBox[{
             RowBox[{"\"\<B\>\"", "|", "\"\<R\>\""}], "\[Rule]", "1"}]}], 
           "}"}]}], ",", "7"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"\"\<row\>\"", "\[Rule]", 
       RowBox[{"First", "@", "a"}]}], ",", 
      RowBox[{"\"\<column\>\"", "\[Rule]", 
       RowBox[{"Last", "@", "a"}]}], ",", 
      RowBox[{"\"\<seat ID\>\"", "\[Rule]", 
       RowBox[{"a", ".", 
        RowBox[{"{", 
         RowBox[{"8", ",", "1"}], "}"}]}]}]}], "\[RightAssociation]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.8176074788169117`*^9, 3.817607593255398*^9}},
 CellLabel->
  "In[162]:=",ExpressionUUID->"7dcc7928-a3b1-4d37-b41c-8b6bfbabe1e2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent5", "[", "\"\<FBFBBFFRLR\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.8176075318125544`*^9, 3.817607538841303*^9}},
 CellLabel->
  "In[163]:=",ExpressionUUID->"b46e80ff-fb7d-460b-8f63-c67f85e37a5a"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"row\"\>", "\[Rule]", "44"}], ",", 
   RowBox[{"\<\"column\"\>", "\[Rule]", "5"}], ",", 
   RowBox[{"\<\"seat ID\"\>", "\[Rule]", "357"}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{3.8176075393794904`*^9, 3.8176075946629868`*^9},
 CellLabel->
  "Out[163]=",ExpressionUUID->"ea755d94-11b1-4467-b99e-370f22772a60"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"advent5", "/@", 
  RowBox[{"{", 
   RowBox[{
   "\"\<BFFFBBFRRR\>\"", ",", "\"\<FFFBBBFRRR\>\"", ",", 
    "\"\<BBFFBBFRLL\>\""}], "}"}]}]], "Input",
 CellChangeTimes->{{3.8176076024001536`*^9, 3.817607616028965*^9}},
 CellLabel->
  "In[164]:=",ExpressionUUID->"bb4b9c19-5a00-43cd-9441-54f6872d146c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{"\<\"row\"\>", "\[Rule]", "70"}], ",", 
     RowBox[{"\<\"column\"\>", "\[Rule]", "7"}], ",", 
     RowBox[{"\<\"seat ID\"\>", "\[Rule]", "567"}]}], "\[RightAssociation]"}],
    ",", 
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{"\<\"row\"\>", "\[Rule]", "14"}], ",", 
     RowBox[{"\<\"column\"\>", "\[Rule]", "7"}], ",", 
     RowBox[{"\<\"seat ID\"\>", "\[Rule]", "119"}]}], "\[RightAssociation]"}],
    ",", 
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{"\<\"row\"\>", "\[Rule]", "102"}], ",", 
     RowBox[{"\<\"column\"\>", "\[Rule]", "4"}], ",", 
     RowBox[{"\<\"seat ID\"\>", "\[Rule]", "820"}]}], 
    "\[RightAssociation]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.817607616505697*^9},
 CellLabel->
  "Out[164]=",ExpressionUUID->"fb46ed71-41be-4658-a777-7ed8db4fedc1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FromDigits", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}],
     "}"}], ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.817607404947369*^9, 3.817607442197234*^9}},
 CellLabel->
  "In[157]:=",ExpressionUUID->"c1a6e3a6-9f32-4494-aa47-b31ec43b7578"],

Cell[BoxData["44"], "Output",
 CellChangeTimes->{3.8176074425371327`*^9},
 CellLabel->
  "Out[157]=",ExpressionUUID->"4ff181aa-8d12-4291-9432-2bb1741b9718"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IntegerDigits", "[", 
  RowBox[{"44", ",", "2", ",", "7"}], "]"}]], "Input",
 CellChangeTimes->{{3.817607446779282*^9, 3.817607452773246*^9}},
 CellLabel->
  "In[159]:=",ExpressionUUID->"bdddf2a8-8569-46d3-84e0-7ee9da423a36"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.8176074492985353`*^9, 3.8176074529856777`*^9}},
 CellLabel->
  "Out[159]=",ExpressionUUID->"925f3fe9-b244-4ad5-9956-f5b080deb993"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"input5a", "=", 
   RowBox[{"StringSplit", "@", 
    RowBox[{
    "GetAOCInput", "[", "\"\<https://adventofcode.com/2020/day/5/input\>\"", 
     "]"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.8176076232703915`*^9, 3.8176076352503242`*^9}},
 CellLabel->
  "In[165]:=",ExpressionUUID->"9a5138cc-1d64-4ff8-869a-6a5ad7e8e0f5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "@", "input5a"}]], "Input",
 CellChangeTimes->{{3.817607635971393*^9, 3.817607638168515*^9}},
 CellLabel->
  "In[166]:=",ExpressionUUID->"ba4dca36-d6e8-42ad-9843-4b02ccaf048e"],

Cell[BoxData["805"], "Output",
 CellChangeTimes->{3.8176076384778132`*^9},
 CellLabel->
  "Out[166]=",ExpressionUUID->"a18f1ad5-3365-4401-818c-bea52944c249"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"input5a", "\[LeftDoubleBracket]", 
  RowBox[{";;", "3"}], "\[RightDoubleBracket]"}]], "Input",
 CellChangeTimes->{{3.8176076393075514`*^9, 3.817607641231406*^9}},
 CellLabel->
  "In[167]:=",ExpressionUUID->"a3fb3d38-a910-4234-80a7-8c06fda803ea"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"FFBBFFFLLL\"\>", ",", "\<\"BFBFBFBLLR\"\>", 
   ",", "\<\"BFFBBBBRRR\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.817607641769986*^9},
 CellLabel->
  "Out[167]=",ExpressionUUID->"6debc85b-8283-49e9-8cb7-c0703e8677af"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"advent5", "/@", "input5a"}], "//", "Max"}]], "Input",
 CellChangeTimes->{{3.8176076446392965`*^9, 3.817607651591383*^9}},
 CellLabel->
  "In[168]:=",ExpressionUUID->"10ebae8a-fa7a-4c2a-b817-7cf6f2f7f0a8"],

Cell[BoxData["890"], "Output",
 CellChangeTimes->{3.8176076518357353`*^9},
 CellLabel->
  "Out[168]=",ExpressionUUID->"49b3fbab-ba2a-4199-a79e-504d5ec1cd35"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", "[", 
  RowBox[{
   RowBox[{"Range", "[", 
    RowBox[{"85", ",", "890"}], "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"advent5", "/@", "input5a"}], ")"}], "\[LeftDoubleBracket]", 
     RowBox[{"All", ",", "\"\<seat ID\>\""}], "\[RightDoubleBracket]"}], "//",
     "Sort"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.817607680988841*^9, 3.817607727573339*^9}},
 CellLabel->
  "In[172]:=",ExpressionUUID->"9c225221-d5fb-4935-8824-3cc43f47c753"],

Cell[BoxData[
 RowBox[{"{", "651", "}"}]], "Output",
 CellChangeTimes->{{3.81760768610017*^9, 3.8176077280560455`*^9}},
 CellLabel->
  "Out[172]=",ExpressionUUID->"d8c0b37a-74f3-41ca-854d-49421c4e34d3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Question 6", "Subsection",
 CellChangeTimes->{{3.8176077380650043`*^9, 
  3.817607739103221*^9}},ExpressionUUID->"7528d557-8d7d-45ec-b11b-\
4c7bab87e4ed"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"input6a", "=", 
  RowBox[{"StringSplit", "[", 
   RowBox[{
   "\"\<abc\n\na\nb\nc\n\nab\nac\n\na\na\na\na\n\nb\>\"", ",", 
    "\"\<\\n\\n\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.817607794100795*^9, 3.81760780191792*^9}},
 CellLabel->
  "In[173]:=",ExpressionUUID->"9f41db38-0ad6-4892-a373-95b8ec0e6adf"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"abc\"\>", ",", "\<\"a\\nb\\nc\"\>", ",", "\<\"ab\\nac\"\>", 
   ",", "\<\"a\\na\\na\\na\"\>", ",", "\<\"b\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.8176078034966965`*^9},
 CellLabel->
  "Out[173]=",ExpressionUUID->"f0a5d265-b663-4a5a-9edb-1ed799dd1177"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LetterCounts", "/*", "Length"}], "/@", "input6a"}], "//", 
  "Total"}]], "Input",
 CellChangeTimes->{{3.8176078239407463`*^9, 3.817607847601887*^9}},
 CellLabel->
  "In[176]:=",ExpressionUUID->"fb7f3f6e-66d9-472f-92c6-ee983b01e201"],

Cell[BoxData["11"], "Output",
 CellChangeTimes->{{3.817607831429239*^9, 3.8176078479746227`*^9}},
 CellLabel->
  "Out[176]=",ExpressionUUID->"56c25109-7fc5-49ed-b861-1895d6d85798"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"input6b", "=", 
   RowBox[{"StringSplit", "[", 
    RowBox[{
     RowBox[{
     "GetAOCInput", "[", 
      "\"\<https://adventofcode.com/2020/day/6/input\!\(\*StyleBox[\"\\\"\",\
FontWeight->\"Plain\"]\)", 
      StyleBox["]",
       FontWeight->"Plain"]}], 
     StyleBox[",",
      FontWeight->"Plain"], 
     StyleBox["\"\<\\n\\n\>\"",
      FontWeight->"Plain"]}], 
    StyleBox["]",
     FontWeight->"Plain"]}]}], 
  StyleBox[";",
   FontWeight->"Plain"]}]], "Input",
 CellChangeTimes->{{3.817607854068116*^9, 3.8176078646039867`*^9}},
 CellLabel->
  "In[177]:=",ExpressionUUID->"12599adb-cb60-478c-aae4-e3fec810932d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LetterCounts", "/*", "Length"}], "/@", "input6b"}], "//", 
  "Total"}]], "Input",
 CellChangeTimes->{{3.8176078711614532`*^9, 3.8176078713130417`*^9}},
 CellLabel->
  "In[178]:=",ExpressionUUID->"836e98c6-f04f-44d1-bb47-f19fc9c25a34"],

Cell[BoxData["6748"], "Output",
 CellChangeTimes->{3.8176078715833187`*^9},
 CellLabel->
  "Out[178]=",ExpressionUUID->"1ef7a1e3-edcf-4133-9f04-7277d982a430"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LetterCounts", "@", "#"}], "&"}], "/@", "input6a"}]], "Input",
 CellChangeTimes->{{3.817607919448681*^9, 3.817607923397151*^9}},
 CellLabel->
  "In[180]:=",ExpressionUUID->"7c16054b-e9d8-4462-81d3-18b889572f0b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{"\<\"c\"\>", "\[Rule]", "1"}], ",", 
     RowBox[{"\<\"b\"\>", "\[Rule]", "1"}], ",", 
     RowBox[{"\<\"a\"\>", "\[Rule]", "1"}]}], "\[RightAssociation]"}], ",", 
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{"\<\"c\"\>", "\[Rule]", "1"}], ",", 
     RowBox[{"\<\"b\"\>", "\[Rule]", "1"}], ",", 
     RowBox[{"\<\"a\"\>", "\[Rule]", "1"}]}], "\[RightAssociation]"}], ",", 
   RowBox[{"\[LeftAssociation]", 
    RowBox[{
     RowBox[{"\<\"a\"\>", "\[Rule]", "2"}], ",", 
     RowBox[{"\<\"c\"\>", "\[Rule]", "1"}], ",", 
     RowBox[{"\<\"b\"\>", "\[Rule]", "1"}]}], "\[RightAssociation]"}], ",", 
   RowBox[{"\[LeftAssociation]", 
    RowBox[{"\<\"a\"\>", "\[Rule]", "4"}], "\[RightAssociation]"}], ",", 
   RowBox[{"\[LeftAssociation]", 
    RowBox[{"\<\"b\"\>", "\[Rule]", "1"}], "\[RightAssociation]"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.8176079238273764`*^9},
 CellLabel->
  "Out[180]=",ExpressionUUID->"72dba94c-74e3-4d20-81bd-52df8e8140f9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Length", "@", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Values", "@", 
        RowBox[{"LetterCounts", "@", "#"}]}], ",", 
       RowBox[{"GreaterThan", "[", 
        RowBox[{"StringCount", "[", 
         RowBox[{"#", ",", "\"\<\\n\>\""}], "]"}], "]"}]}], "]"}]}], "&"}], "/@",
    "input6a"}], "//", "Total"}]], "Input",
 CellChangeTimes->{{3.8176078711614532`*^9, 3.8176080378940125`*^9}},
 CellLabel->
  "In[190]:=",ExpressionUUID->"4b252f27-9ba9-48e3-bde0-e2084b861325"],

Cell[BoxData["6"], "Output",
 CellChangeTimes->{{3.817607907962758*^9, 3.8176080384525185`*^9}},
 CellLabel->
  "Out[190]=",ExpressionUUID->"dec5e2f4-8960-4cd0-b036-8e16bb7e1c66"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Length", "@", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Values", "@", 
        RowBox[{"LetterCounts", "@", "#"}]}], ",", 
       RowBox[{"EqualTo", "[", 
        RowBox[{"1", "+", 
         RowBox[{"StringCount", "[", 
          RowBox[{
           RowBox[{"StringTrim", "@", "#"}], ",", "\"\<\\n\>\""}], "]"}]}], 
        "]"}]}], "]"}]}], "&"}], "/@", "input6b"}], "//", "Total"}]], "Input",
 CellChangeTimes->{{3.8176078711614532`*^9, 3.8176080748920755`*^9}},
 CellLabel->
  "In[193]:=",ExpressionUUID->"9e0f76d9-847a-4de8-9a94-b53aac0f1c59"],

Cell[BoxData["3445"], "Output",
 CellChangeTimes->{{3.8176080415604987`*^9, 3.81760807533888*^9}},
 CellLabel->
  "Out[193]=",ExpressionUUID->"d96a8ade-de3c-4e74-8900-f46b3a538006"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StringCount", "[", 
    RowBox[{
     RowBox[{"StringTrim", "@", "#"}], ",", "\"\<\\n\>\""}], "]"}], "&"}], "/@",
   "input6a"}]], "Input",
 CellChangeTimes->{{3.8176079461851444`*^9, 3.817607967890016*^9}, {
  3.8176080952577915`*^9, 3.8176080964745426`*^9}},
 CellLabel->
  "In[194]:=",ExpressionUUID->"bf0a5356-0b66-4015-be77-0eac491c36ca"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "2", ",", "1", ",", "3", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.817607948750512*^9, 3.817607968041611*^9}, 
   3.817608096966685*^9},
 CellLabel->
  "Out[194]=",ExpressionUUID->"8e654027-6f14-476a-98af-1ce0de81d1ff"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1148, 980},
WindowMargins->{{2, Automatic}, {-4, Automatic}},
Magnification:>1.25 Inherited,
FrontEndVersion->"12.2 for Microsoft Windows (64-bit) (December 14, 2020)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"44b449eb-2834-4e87-90e2-e9950cde3da1"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 164, 3, 83, "Section",ExpressionUUID->"9f6a3a69-2e05-42e1-becc-f96eacfc3532"],
Cell[747, 27, 1076, 24, 60, "Input",ExpressionUUID->"3ff4b0f9-7b31-45e0-b8ae-a72994a5adbc"],
Cell[1826, 53, 751, 15, 35, "Input",ExpressionUUID->"0b489f49-6ddc-4734-976e-31a961b7589f"],
Cell[CellGroupData[{
Cell[2602, 72, 236, 5, 35, "Input",ExpressionUUID->"edef68a2-135a-4d12-9da8-3c4afc20be6f"],
Cell[2841, 79, 31729, 567, 113, "Output",ExpressionUUID->"40170276-a1d5-46bf-9d0a-03af60e46ee3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[34619, 652, 181, 3, 83, "Section",ExpressionUUID->"09ab1934-74f9-429c-980e-769413ef9dfc"],
Cell[CellGroupData[{
Cell[34825, 659, 162, 3, 67, "Subsection",ExpressionUUID->"c9e9fec9-6959-4b3d-9993-be61321c7dd7"],
Cell[34990, 664, 292, 5, 35, "Input",ExpressionUUID->"81515197-5b2b-4a1f-8b47-37e6a4395dfb"],
Cell[CellGroupData[{
Cell[35307, 673, 282, 5, 156, "Input",ExpressionUUID->"8f4f9a2c-6ab5-4336-abe3-d8ad448a8239"],
Cell[35592, 680, 256, 6, 40, "Output",ExpressionUUID->"3a6fda08-c0cf-4b94-b76f-38639ed8f964"]
}, Open  ]],
Cell[35863, 689, 774, 21, 60, "Input",ExpressionUUID->"e64b3632-ed67-483d-945b-fab9da0acb11"],
Cell[CellGroupData[{
Cell[36662, 714, 260, 5, 35, "Input",ExpressionUUID->"92dd65a7-5c0a-4b6e-a29b-acd1574427a1"],
Cell[36925, 721, 150, 2, 40, "Output",ExpressionUUID->"8494bbc2-9183-4149-8ee8-d1ddc8b0000d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37112, 728, 463, 9, 35, "Input",ExpressionUUID->"3562818f-17da-4403-b532-fb5099255682"],
Cell[37578, 739, 257, 4, 40, "Output",ExpressionUUID->"8802e990-7ffd-46ba-a14e-bd45aee7739f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37872, 748, 546, 11, 35, "Input",ExpressionUUID->"d7e962c6-2144-4516-aea3-a0d84094b185"],
Cell[38421, 761, 157, 2, 40, "Output",ExpressionUUID->"59014fc7-238b-4101-9a31-0e3d51198dae"]
}, Open  ]],
Cell[38593, 766, 239, 4, 35, "Input",ExpressionUUID->"53238441-ca6c-4024-a679-145c73e9a12e"],
Cell[38835, 772, 707, 18, 60, "Input",ExpressionUUID->"2c34f859-9171-47e1-b6fb-9d1d93dc528b"],
Cell[39545, 792, 419, 10, 35, "Input",ExpressionUUID->"0307294d-acc6-4d87-8d0d-afa56b9e585b"],
Cell[39967, 804, 759, 16, 35, "Input",ExpressionUUID->"06d71425-da00-4ac4-be28-264dfccc7197"],
Cell[CellGroupData[{
Cell[40751, 824, 208, 3, 35, "Input",ExpressionUUID->"ffdc6c4b-111c-441c-95d3-3243fc5a5b0d"],
Cell[40962, 829, 155, 2, 40, "Output",ExpressionUUID->"c171ae39-c3b8-4fda-9f0c-71b9706f87b4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41154, 836, 232, 4, 35, "Input",ExpressionUUID->"d000d861-43b5-4e62-9fa7-83b63809c976"],
Cell[41389, 842, 225, 4, 40, "Output",ExpressionUUID->"bdabae97-77d3-4381-9aee-1a0b7c93aa09"]
}, Open  ]],
Cell[41629, 849, 215, 3, 35, "Input",ExpressionUUID->"30fca804-40fd-4e8c-be2e-5c4262c2fc82"],
Cell[CellGroupData[{
Cell[41869, 856, 207, 3, 35, "Input",ExpressionUUID->"5bbcc0db-b826-4b32-a303-664dffd62c7b"],
Cell[42079, 861, 151, 2, 40, "Output",ExpressionUUID->"1eef6bbd-7af3-43f1-9ec5-8b45f98149ff"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42267, 868, 286, 6, 35, "Input",ExpressionUUID->"835c3248-326f-4265-8612-802e3eca72ed"],
Cell[42556, 876, 157, 2, 40, "Output",ExpressionUUID->"13773d17-9b40-4a50-8a07-8b7bf6fa4856"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42750, 883, 404, 11, 35, "Input",ExpressionUUID->"9314552b-505b-4226-a304-549d628ee779"],
Cell[43157, 896, 260, 5, 40, "Output",ExpressionUUID->"808604a9-9fa7-4cc4-99d3-5e0e26e9d0c3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43454, 906, 228, 4, 35, "Input",ExpressionUUID->"4515c699-3953-4bd8-95b7-bdbe0362da7f"],
Cell[43685, 912, 158, 2, 40, "Output",ExpressionUUID->"22e9ca08-6adc-46ff-bd07-a482cfaed0f4"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[43892, 920, 157, 3, 67, "Subsection",ExpressionUUID->"67f20222-c8b5-4b71-8685-0db19a4b4c8b"],
Cell[CellGroupData[{
Cell[44074, 927, 387, 8, 84, "Input",ExpressionUUID->"0ada1e5e-f807-445c-965b-a4a067a3ce25"],
Cell[44464, 937, 292, 5, 40, "Output",ExpressionUUID->"96262b4e-d91e-4ef1-b998-051b57866738"]
}, Open  ]],
Cell[44771, 945, 1519, 38, 132, "Input",ExpressionUUID->"f862e66e-1909-4810-bc66-44ae28470609"],
Cell[CellGroupData[{
Cell[46315, 987, 206, 3, 35, "Input",ExpressionUUID->"1fb6da1e-7df6-4129-a670-f29f0704c9a9"],
Cell[46524, 992, 149, 2, 40, "Output",ExpressionUUID->"4b7d3e22-cd4e-4b76-8206-707592bd4e3c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46710, 999, 210, 3, 35, "Input",ExpressionUUID->"1a847c8f-012b-4972-a2a7-1ebec5169f03"],
Cell[46923, 1004, 153, 2, 40, "Output",ExpressionUUID->"0d8b9def-42ea-4f67-b846-07d91d110674"]
}, Open  ]],
Cell[47091, 1009, 487, 11, 35, "Input",ExpressionUUID->"b61326d0-2ffb-4c0a-bd10-47bc836812ae"],
Cell[CellGroupData[{
Cell[47603, 1024, 225, 3, 35, "Input",ExpressionUUID->"570d0480-86a9-49de-a8a2-4c00972e379f"],
Cell[47831, 1029, 351, 6, 40, "Output",ExpressionUUID->"53cd2f58-d480-47ff-9cab-72839827077f"]
}, Open  ]],
Cell[48197, 1038, 1422, 37, 132, "Input",ExpressionUUID->"a8fe9417-34a0-477f-943c-5c2b2b421a94"],
Cell[CellGroupData[{
Cell[49644, 1079, 211, 3, 35, "Input",ExpressionUUID->"c682ded0-d8a0-4c2d-9118-678d98285782"],
Cell[49858, 1084, 173, 2, 40, "Output",ExpressionUUID->"f23551e0-0a9d-4df2-b9d5-1178489889cd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50068, 1091, 259, 4, 35, "Input",ExpressionUUID->"c08c69b1-508c-4ae2-a76f-a67a6d4979cf"],
Cell[50330, 1097, 151, 2, 40, "Output",ExpressionUUID->"91f475da-a4aa-4aa0-b325-0990b418cb21"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[50530, 1105, 160, 3, 67, "Subsection",ExpressionUUID->"b081776a-d67c-4e72-8d87-209becffc835"],
Cell[CellGroupData[{
Cell[50715, 1112, 428, 9, 276, "Input",ExpressionUUID->"8475b5ab-33b8-4b40-8c81-40c5840228f7"],
Cell[51146, 1123, 2942, 49, 113, "Output",ExpressionUUID->"e5b8ae80-a6d8-4047-9dc8-ad300339cfc5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54125, 1177, 422, 11, 35, "Input",ExpressionUUID->"66c151de-926f-4097-97ac-cb68570f6b57"],
Cell[54550, 1190, 305, 6, 40, "Output",ExpressionUUID->"d9c27b43-c7ea-4e31-a1b0-4340001a3649"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54892, 1201, 201, 3, 35, "Input",ExpressionUUID->"f926cd68-3716-4fdd-84da-2d3bbaeb322d"],
Cell[55096, 1206, 152, 2, 40, "Output",ExpressionUUID->"f8de8db0-c370-48fa-8a3c-d5cee13c489b"]
}, Open  ]],
Cell[55263, 1211, 1040, 28, 108, "Input",ExpressionUUID->"24ef65f1-e424-468e-8362-e024ec156ca9"],
Cell[CellGroupData[{
Cell[56328, 1243, 211, 3, 35, "Input",ExpressionUUID->"5aced434-9e0e-4f0d-b034-caed485e8ca7"],
Cell[56542, 1248, 151, 2, 40, "Output",ExpressionUUID->"0f1c09f6-fc68-4f79-a540-6b73ef454cb2"]
}, Open  ]],
Cell[56708, 1253, 389, 9, 35, "Input",ExpressionUUID->"e04b9fa9-8d88-4005-81c7-acdfa33f1fe6"],
Cell[CellGroupData[{
Cell[57122, 1266, 258, 4, 35, "Input",ExpressionUUID->"b6815dbf-6c0a-4473-86a9-faee3ecd24ef"],
Cell[57383, 1272, 175, 2, 40, "Output",ExpressionUUID->"6277a593-d11d-454f-9cd0-a48b1a9dab02"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57595, 1279, 216, 3, 35, "Input",ExpressionUUID->"925c89c3-8153-45e4-8282-00972a5553b1"],
Cell[57814, 1284, 151, 2, 40, "Output",ExpressionUUID->"f1d7a393-f2d2-4941-8cfc-ab90ed84b998"]
}, Open  ]],
Cell[57980, 1289, 1047, 29, 108, "Input",ExpressionUUID->"27adf3ee-e3eb-4a5a-bf96-e3b3b33a9b6c"],
Cell[CellGroupData[{
Cell[59052, 1322, 347, 8, 35, "Input",ExpressionUUID->"a34141bc-5177-4356-89c8-7a7f07279015"],
Cell[59402, 1332, 216, 4, 40, "Output",ExpressionUUID->"2630fde9-d4cc-4bd3-896a-474fe819eae7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59655, 1341, 335, 7, 35, "Input",ExpressionUUID->"c7661930-9dd0-425d-beba-0d39686ba08e"],
Cell[59993, 1350, 172, 2, 40, "Output",ExpressionUUID->"b584e7b7-f59a-4e46-8fa9-d5eab68b6e28"]
}, Open  ]],
Cell[60180, 1355, 693, 18, 35, "Input",ExpressionUUID->"34df91bf-4e7e-470a-9787-99c5918f30b9"],
Cell[CellGroupData[{
Cell[60898, 1377, 212, 3, 35, "Input",ExpressionUUID->"f827f21c-2d6c-4ae7-8fb9-f4c16d709c6b"],
Cell[61113, 1382, 153, 2, 40, "Output",ExpressionUUID->"d0fd1b31-9551-4965-9ee2-d9d71a267f69"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61303, 1389, 218, 4, 35, "Input",ExpressionUUID->"6570df4d-05b7-45aa-8e40-b0d53530bb43"],
Cell[61524, 1395, 164, 3, 40, "Output",ExpressionUUID->"f8c48c67-6701-426f-a1f1-f52c5ffca1a9"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[61737, 1404, 162, 3, 67, "Subsection",ExpressionUUID->"47bf3f43-e4f5-4f87-a0bf-1da373ed2e8f"],
Cell[CellGroupData[{
Cell[61924, 1411, 594, 11, 324, "Input",ExpressionUUID->"ecde275d-0e96-4870-9b48-e33ee9f3d11d"],
Cell[62521, 1424, 554, 12, 185, "Output",ExpressionUUID->"8da5847d-18a1-43c2-b4cf-df5fb628bac6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63112, 1441, 457, 12, 35, "Input",ExpressionUUID->"4d1489fc-5dd3-4aea-af43-ab803ece2712"],
Cell[63572, 1455, 397, 11, 40, "Output",ExpressionUUID->"efb02205-6b7b-4126-a844-c598382e0c3e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[64006, 1471, 324, 7, 35, "Input",ExpressionUUID->"8197903b-7ae5-4924-a89f-647f27661660"],
Cell[64333, 1480, 398, 8, 40, "Output",ExpressionUUID->"4a52248d-1f2e-41fb-8cfc-1e187f5eca58"]
}, Open  ]],
Cell[CellGroupData[{
Cell[64768, 1493, 511, 14, 35, "Input",ExpressionUUID->"39fc329d-102b-42ec-ad77-22050b1c62ba"],
Cell[65282, 1509, 179, 3, 40, "Output",ExpressionUUID->"6ccd86df-ea32-4c1f-9c4a-76a0a0cf2b05"]
}, Open  ]],
Cell[CellGroupData[{
Cell[65498, 1517, 511, 14, 35, "Input",ExpressionUUID->"a3eff975-ff6a-48f7-b12c-de039709744f"],
Cell[66012, 1533, 157, 3, 40, "Output",ExpressionUUID->"d9e50b17-c5ec-4db4-b4ca-8a7024e0244a"]
}, Open  ]],
Cell[66184, 1539, 403, 10, 35, "Input",ExpressionUUID->"4d6951e4-688a-49e4-b33f-08e42745ce10"],
Cell[66590, 1551, 157, 3, 35, "Input",ExpressionUUID->"38648cf1-a1f3-4a34-a3c0-c5d5c8f38028"],
Cell[CellGroupData[{
Cell[66772, 1558, 668, 18, 37, "Input",ExpressionUUID->"43635550-bb64-49c4-b0a9-5e95bafeb53f"],
Cell[67443, 1578, 627, 17, 66, "Output",ExpressionUUID->"c91011e7-7c87-43af-8dff-616900656f05"]
}, Open  ]],
Cell[CellGroupData[{
Cell[68107, 1600, 326, 7, 35, "Input",ExpressionUUID->"c61e2749-25cb-4224-a390-9af30e0cc211"],
Cell[68436, 1609, 729, 14, 40, "Output",ExpressionUUID->"6f0e9aa2-2655-4504-8c0e-4ab8e4ce016f"]
}, Open  ]],
Cell[69180, 1626, 2969, 77, 181, "Input",ExpressionUUID->"b88ae840-a77b-42cd-9ae8-1e5b687e6e24"],
Cell[CellGroupData[{
Cell[72174, 1707, 692, 21, 35, "Input",ExpressionUUID->"0582b6b8-e3be-419c-b306-7e8a2f1ae711"],
Cell[72869, 1730, 664, 15, 40, "Output",ExpressionUUID->"7682aaaf-2024-4935-a873-d44c26e4ae5e"]
}, Open  ]],
Cell[73548, 1748, 638, 13, 300, "Input",ExpressionUUID->"22a81657-1529-4f33-9459-88989d6aa94f"],
Cell[74189, 1763, 639, 13, 324, "Input",ExpressionUUID->"79008b19-c89f-4db4-86c2-ac298e0fb4dc"],
Cell[CellGroupData[{
Cell[74853, 1780, 997, 28, 132, "Input",ExpressionUUID->"1873585f-1986-48a1-85e8-738d30ad6249"],
Cell[75853, 1810, 260, 6, 40, "Output",ExpressionUUID->"f475e4de-f733-42d3-b209-b741433657a9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76150, 1821, 1097, 30, 132, "Input",ExpressionUUID->"79689c1f-afaa-4221-9081-c36994e31386"],
Cell[77250, 1853, 329, 7, 40, "Output",ExpressionUUID->"dde4a73e-431e-4668-9098-7579b4224413"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77616, 1865, 319, 7, 35, "Input",ExpressionUUID->"b60b459d-b4c5-412b-b4b3-cb829c3a1449"],
Cell[77938, 1874, 397, 8, 161, "Output",ExpressionUUID->"ef251e81-8246-43ee-bb7a-62d0f219383e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78372, 1887, 1347, 35, 156, "Input",ExpressionUUID->"5b540469-a344-45ea-ac26-450a8298c718"],
Cell[79722, 1924, 211, 4, 40, "Output",ExpressionUUID->"5d201107-417e-4a34-9e0a-c2d1512cadf3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[79982, 1934, 160, 3, 67, "Subsection",ExpressionUUID->"09b913ed-2feb-49e5-9e77-70c412e9d1ea"],
Cell[CellGroupData[{
Cell[80167, 1941, 234, 5, 35, "Input",ExpressionUUID->"8862db79-9d5f-43ed-acde-ce7fe646ebd5"],
Cell[80404, 1948, 153, 3, 40, "Output",ExpressionUUID->"6a85eacc-424a-457d-a08a-7b37781340f4"]
}, Open  ]],
Cell[80572, 1954, 1252, 35, 61, "Input",ExpressionUUID->"7dcc7928-a3b1-4d37-b41c-8b6bfbabe1e2"],
Cell[CellGroupData[{
Cell[81849, 1993, 228, 4, 35, "Input",ExpressionUUID->"b46e80ff-fb7d-460b-8f63-c67f85e37a5a"],
Cell[82080, 1999, 402, 9, 40, "Output",ExpressionUUID->"ea755d94-11b1-4467-b99e-370f22772a60"]
}, Open  ]],
Cell[CellGroupData[{
Cell[82519, 2013, 324, 8, 35, "Input",ExpressionUUID->"bb4b9c19-5a00-43cd-9441-54f6872d146c"],
Cell[82846, 2023, 912, 23, 65, "Output",ExpressionUUID->"fb46ed71-41be-4658-a777-7ed8db4fedc1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[83795, 2051, 339, 8, 35, "Input",ExpressionUUID->"c1a6e3a6-9f32-4494-aa47-b31ec43b7578"],
Cell[84137, 2061, 156, 3, 40, "Output",ExpressionUUID->"4ff181aa-8d12-4291-9432-2bb1741b9718"]
}, Open  ]],
Cell[CellGroupData[{
Cell[84330, 2069, 249, 5, 35, "Input",ExpressionUUID->"bdddf2a8-8569-46d3-84e0-7ee9da423a36"],
Cell[84582, 2076, 279, 6, 40, "Output",ExpressionUUID->"925f3fe9-b244-4ad5-9956-f5b080deb993"]
}, Open  ]],
Cell[84876, 2085, 359, 9, 35, "Input",ExpressionUUID->"9a5138cc-1d64-4ff8-869a-6a5ad7e8e0f5"],
Cell[CellGroupData[{
Cell[85260, 2098, 209, 4, 35, "Input",ExpressionUUID->"ba4dca36-d6e8-42ad-9843-4b02ccaf048e"],
Cell[85472, 2104, 157, 3, 40, "Output",ExpressionUUID->"a18f1ad5-3365-4401-818c-bea52944c249"]
}, Open  ]],
Cell[CellGroupData[{
Cell[85666, 2112, 269, 5, 35, "Input",ExpressionUUID->"a3fb3d38-a910-4234-80a7-8c06fda803ea"],
Cell[85938, 2119, 263, 6, 40, "Output",ExpressionUUID->"6debc85b-8283-49e9-8cb7-c0703e8677af"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86238, 2130, 239, 5, 35, "Input",ExpressionUUID->"10ebae8a-fa7a-4c2a-b817-7cf6f2f7f0a8"],
Cell[86480, 2137, 157, 3, 40, "Output",ExpressionUUID->"49b3fbab-ba2a-4199-a79e-504d5ec1cd35"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86674, 2145, 506, 13, 35, "Input",ExpressionUUID->"9c225221-d5fb-4935-8824-3cc43f47c753"],
Cell[87183, 2160, 202, 4, 40, "Output",ExpressionUUID->"d8c0b37a-74f3-41ca-854d-49421c4e34d3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[87434, 2170, 160, 3, 67, "Subsection",ExpressionUUID->"7528d557-8d7d-45ec-b11b-4c7bab87e4ed"],
Cell[CellGroupData[{
Cell[87619, 2177, 337, 8, 372, "Input",ExpressionUUID->"9f41db38-0ad6-4892-a373-95b8ec0e6adf"],
Cell[87959, 2187, 302, 6, 185, "Output",ExpressionUUID->"f0a5d265-b663-4a5a-9edb-1ed799dd1177"]
}, Open  ]],
Cell[CellGroupData[{
Cell[88298, 2198, 279, 7, 35, "Input",ExpressionUUID->"fb7f3f6e-66d9-472f-92c6-ee983b01e201"],
Cell[88580, 2207, 180, 3, 40, "Output",ExpressionUUID->"56c25109-7fc5-49ed-b861-1895d6d85798"]
}, Open  ]],
Cell[88775, 2213, 658, 21, 35, "Input",ExpressionUUID->"12599adb-cb60-478c-aae4-e3fec810932d"],
Cell[CellGroupData[{
Cell[89458, 2238, 281, 7, 35, "Input",ExpressionUUID->"836e98c6-f04f-44d1-bb47-f19fc9c25a34"],
Cell[89742, 2247, 158, 3, 40, "Output",ExpressionUUID->"1ef7a1e3-edcf-4133-9f04-7277d982a430"]
}, Open  ]],
Cell[CellGroupData[{
Cell[89937, 2255, 258, 6, 35, "Input",ExpressionUUID->"7c16054b-e9d8-4462-81d3-18b889572f0b"],
Cell[90198, 2263, 1071, 25, 40, "Output",ExpressionUUID->"72dba94c-74e3-4d20-81bd-52df8e8140f9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91306, 2293, 553, 15, 35, "Input",ExpressionUUID->"4b252f27-9ba9-48e3-bde0-e2084b861325"],
Cell[91862, 2310, 179, 3, 40, "Output",ExpressionUUID->"dec5e2f4-8960-4cd0-b036-8e16bb7e1c66"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92078, 2318, 626, 17, 60, "Input",ExpressionUUID->"9e0f76d9-847a-4de8-9a94-b53aac0f1c59"],
Cell[92707, 2337, 181, 3, 40, "Output",ExpressionUUID->"d96a8ade-de3c-4e74-8900-f46b3a538006"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92925, 2345, 390, 10, 35, "Input",ExpressionUUID->"bf0a5356-0b66-4015-be77-0eac491c36ca"],
Cell[93318, 2357, 278, 6, 40, "Output",ExpressionUUID->"8e654027-6f14-476a-98af-1ce0de81d1ff"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

